<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAgencyCreditCardInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAgencyCreditCardInfo
 * @subpackage Arrays
 */
class ArrayOfAgencyCreditCardInfo extends AbstractStructArrayBase
{
    /**
     * The AgencyCreditCardInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AgencyCreditCardInfo[]
     */
    public $AgencyCreditCardInfo;
    /**
     * Constructor method for ArrayOfAgencyCreditCardInfo
     * @uses ArrayOfAgencyCreditCardInfo::setAgencyCreditCardInfo()
     * @param \StructType\AgencyCreditCardInfo[] $agencyCreditCardInfo
     */
    public function __construct(array $agencyCreditCardInfo = array())
    {
        $this
            ->setAgencyCreditCardInfo($agencyCreditCardInfo);
    }
    /**
     * Get AgencyCreditCardInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AgencyCreditCardInfo[]|null
     */
    public function getAgencyCreditCardInfo()
    {
        return isset($this->AgencyCreditCardInfo) ? $this->AgencyCreditCardInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAgencyCreditCardInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAgencyCreditCardInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAgencyCreditCardInfoForArrayConstraintsFromSetAgencyCreditCardInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAgencyCreditCardInfoAgencyCreditCardInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfAgencyCreditCardInfoAgencyCreditCardInfoItem instanceof \StructType\AgencyCreditCardInfo) {
                $invalidValues[] = is_object($arrayOfAgencyCreditCardInfoAgencyCreditCardInfoItem) ? get_class($arrayOfAgencyCreditCardInfoAgencyCreditCardInfoItem) : sprintf('%s(%s)', gettype($arrayOfAgencyCreditCardInfoAgencyCreditCardInfoItem), var_export($arrayOfAgencyCreditCardInfoAgencyCreditCardInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AgencyCreditCardInfo property can only contain items of type \StructType\AgencyCreditCardInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AgencyCreditCardInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AgencyCreditCardInfo[] $agencyCreditCardInfo
     * @return \ArrayType\ArrayOfAgencyCreditCardInfo
     */
    public function setAgencyCreditCardInfo(array $agencyCreditCardInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($agencyCreditCardInfoArrayErrorMessage = self::validateAgencyCreditCardInfoForArrayConstraintsFromSetAgencyCreditCardInfo($agencyCreditCardInfo))) {
            throw new \InvalidArgumentException($agencyCreditCardInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($agencyCreditCardInfo) || (is_array($agencyCreditCardInfo) && empty($agencyCreditCardInfo))) {
            unset($this->AgencyCreditCardInfo);
        } else {
            $this->AgencyCreditCardInfo = $agencyCreditCardInfo;
        }
        return $this;
    }
    /**
     * Add item to AgencyCreditCardInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\AgencyCreditCardInfo $item
     * @return \ArrayType\ArrayOfAgencyCreditCardInfo
     */
    public function addToAgencyCreditCardInfo(\StructType\AgencyCreditCardInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AgencyCreditCardInfo) {
            throw new \InvalidArgumentException(sprintf('The AgencyCreditCardInfo property can only contain items of type \StructType\AgencyCreditCardInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AgencyCreditCardInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AgencyCreditCardInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AgencyCreditCardInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AgencyCreditCardInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AgencyCreditCardInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AgencyCreditCardInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AgencyCreditCardInfo
     */
    public function getAttributeName()
    {
        return 'AgencyCreditCardInfo';
    }
}
