<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAgencyPNR ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAgencyPNR
 * @subpackage Arrays
 */
class ArrayOfAgencyPNR extends AbstractStructArrayBase
{
    /**
     * The AgencyPNR
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AgencyPNR[]
     */
    public $AgencyPNR;
    /**
     * Constructor method for ArrayOfAgencyPNR
     * @uses ArrayOfAgencyPNR::setAgencyPNR()
     * @param \StructType\AgencyPNR[] $agencyPNR
     */
    public function __construct(array $agencyPNR = array())
    {
        $this
            ->setAgencyPNR($agencyPNR);
    }
    /**
     * Get AgencyPNR value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AgencyPNR[]|null
     */
    public function getAgencyPNR()
    {
        return isset($this->AgencyPNR) ? $this->AgencyPNR : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAgencyPNR method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAgencyPNR method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAgencyPNRForArrayConstraintsFromSetAgencyPNR(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAgencyPNRAgencyPNRItem) {
            // validation for constraint: itemType
            if (!$arrayOfAgencyPNRAgencyPNRItem instanceof \StructType\AgencyPNR) {
                $invalidValues[] = is_object($arrayOfAgencyPNRAgencyPNRItem) ? get_class($arrayOfAgencyPNRAgencyPNRItem) : sprintf('%s(%s)', gettype($arrayOfAgencyPNRAgencyPNRItem), var_export($arrayOfAgencyPNRAgencyPNRItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AgencyPNR property can only contain items of type \StructType\AgencyPNR, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AgencyPNR value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AgencyPNR[] $agencyPNR
     * @return \ArrayType\ArrayOfAgencyPNR
     */
    public function setAgencyPNR(array $agencyPNR = array())
    {
        // validation for constraint: array
        if ('' !== ($agencyPNRArrayErrorMessage = self::validateAgencyPNRForArrayConstraintsFromSetAgencyPNR($agencyPNR))) {
            throw new \InvalidArgumentException($agencyPNRArrayErrorMessage, __LINE__);
        }
        if (is_null($agencyPNR) || (is_array($agencyPNR) && empty($agencyPNR))) {
            unset($this->AgencyPNR);
        } else {
            $this->AgencyPNR = $agencyPNR;
        }
        return $this;
    }
    /**
     * Add item to AgencyPNR value
     * @throws \InvalidArgumentException
     * @param \StructType\AgencyPNR $item
     * @return \ArrayType\ArrayOfAgencyPNR
     */
    public function addToAgencyPNR(\StructType\AgencyPNR $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AgencyPNR) {
            throw new \InvalidArgumentException(sprintf('The AgencyPNR property can only contain items of type \StructType\AgencyPNR, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AgencyPNR[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AgencyPNR|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AgencyPNR|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AgencyPNR|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AgencyPNR|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AgencyPNR|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AgencyPNR
     */
    public function getAttributeName()
    {
        return 'AgencyPNR';
    }
}
