<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEnumerations.AgencyFields ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEnumerations.AgencyFields
 * @subpackage Arrays
 */
class ArrayOfEnumerations_AgencyFields extends AbstractStructArrayBase
{
    /**
     * The Enumerations_AgencyFields
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $Enumerations_AgencyFields;
    /**
     * Constructor method for ArrayOfEnumerations.AgencyFields
     * @uses ArrayOfEnumerations_AgencyFields::setEnumerations_AgencyFields()
     * @param string[] $enumerations_AgencyFields
     */
    public function __construct(array $enumerations_AgencyFields = array())
    {
        $this
            ->setEnumerations_AgencyFields($enumerations_AgencyFields);
    }
    /**
     * Get Enumerations_AgencyFields value
     * @return string[]|null
     */
    public function getEnumerations_AgencyFields()
    {
        return $this->{'Enumerations.AgencyFields'};
    }
    /**
     * This method is responsible for validating the values passed to the setEnumerations_AgencyFields method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEnumerations_AgencyFields method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEnumerations_AgencyFieldsForArrayConstraintsFromSetEnumerations_AgencyFields(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEnumerations_AgencyFieldsEnumerations_AgencyFieldsItem) {
            // validation for constraint: enumeration
            if (!\EnumType\Enumerations_AgencyFields::valueIsValid($arrayOfEnumerations_AgencyFieldsEnumerations_AgencyFieldsItem)) {
                $invalidValues[] = is_object($arrayOfEnumerations_AgencyFieldsEnumerations_AgencyFieldsItem) ? get_class($arrayOfEnumerations_AgencyFieldsEnumerations_AgencyFieldsItem) : sprintf('%s(%s)', gettype($arrayOfEnumerations_AgencyFieldsEnumerations_AgencyFieldsItem), var_export($arrayOfEnumerations_AgencyFieldsEnumerations_AgencyFieldsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\Enumerations_AgencyFields', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\Enumerations_AgencyFields::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Enumerations_AgencyFields value
     * @uses \EnumType\Enumerations_AgencyFields::valueIsValid()
     * @uses \EnumType\Enumerations_AgencyFields::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $enumerations_AgencyFields
     * @return \ArrayType\ArrayOfEnumerations_AgencyFields
     */
    public function setEnumerations_AgencyFields(array $enumerations_AgencyFields = array())
    {
        // validation for constraint: array
        if ('' !== ($enumerations_AgencyFieldsArrayErrorMessage = self::validateEnumerations_AgencyFieldsForArrayConstraintsFromSetEnumerations_AgencyFields($enumerations_AgencyFields))) {
            throw new \InvalidArgumentException($enumerations_AgencyFieldsArrayErrorMessage, __LINE__);
        }
        $this->Enumerations_AgencyFields = $this->{'Enumerations.AgencyFields'} = $enumerations_AgencyFields;
        return $this;
    }
    /**
     * Add item to Enumerations_AgencyFields value
     * @uses \EnumType\Enumerations_AgencyFields::valueIsValid()
     * @uses \EnumType\Enumerations_AgencyFields::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfEnumerations_AgencyFields
     */
    public function addToEnumerations_AgencyFields($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\Enumerations_AgencyFields::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\Enumerations_AgencyFields', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\Enumerations_AgencyFields::getValidValues())), __LINE__);
        }
        $this->Enumerations_AgencyFields[] = $this->{'Enumerations.AgencyFields'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\Enumerations_AgencyFields::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfEnumerations_AgencyFields
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\Enumerations_AgencyFields::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\Enumerations_AgencyFields', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\Enumerations_AgencyFields::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Enumerations.AgencyFields
     */
    public function getAttributeName()
    {
        return 'Enumerations.AgencyFields';
    }
}
