<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEnumerations.SegmentStatus ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEnumerations.SegmentStatus
 * @subpackage Arrays
 */
class ArrayOfEnumerations_SegmentStatus extends AbstractStructArrayBase
{
    /**
     * The Enumerations_SegmentStatus
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $Enumerations_SegmentStatus;
    /**
     * Constructor method for ArrayOfEnumerations.SegmentStatus
     * @uses ArrayOfEnumerations_SegmentStatus::setEnumerations_SegmentStatus()
     * @param string[] $enumerations_SegmentStatus
     */
    public function __construct(array $enumerations_SegmentStatus = array())
    {
        $this
            ->setEnumerations_SegmentStatus($enumerations_SegmentStatus);
    }
    /**
     * Get Enumerations_SegmentStatus value
     * @return string[]|null
     */
    public function getEnumerations_SegmentStatus()
    {
        return $this->{'Enumerations.SegmentStatus'};
    }
    /**
     * This method is responsible for validating the values passed to the setEnumerations_SegmentStatus method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEnumerations_SegmentStatus method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEnumerations_SegmentStatusForArrayConstraintsFromSetEnumerations_SegmentStatus(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEnumerations_SegmentStatusEnumerations_SegmentStatusItem) {
            // validation for constraint: enumeration
            if (!\EnumType\Enumerations_SegmentStatus::valueIsValid($arrayOfEnumerations_SegmentStatusEnumerations_SegmentStatusItem)) {
                $invalidValues[] = is_object($arrayOfEnumerations_SegmentStatusEnumerations_SegmentStatusItem) ? get_class($arrayOfEnumerations_SegmentStatusEnumerations_SegmentStatusItem) : sprintf('%s(%s)', gettype($arrayOfEnumerations_SegmentStatusEnumerations_SegmentStatusItem), var_export($arrayOfEnumerations_SegmentStatusEnumerations_SegmentStatusItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\Enumerations_SegmentStatus', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \EnumType\Enumerations_SegmentStatus::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Enumerations_SegmentStatus value
     * @uses \EnumType\Enumerations_SegmentStatus::valueIsValid()
     * @uses \EnumType\Enumerations_SegmentStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $enumerations_SegmentStatus
     * @return \ArrayType\ArrayOfEnumerations_SegmentStatus
     */
    public function setEnumerations_SegmentStatus(array $enumerations_SegmentStatus = array())
    {
        // validation for constraint: array
        if ('' !== ($enumerations_SegmentStatusArrayErrorMessage = self::validateEnumerations_SegmentStatusForArrayConstraintsFromSetEnumerations_SegmentStatus($enumerations_SegmentStatus))) {
            throw new \InvalidArgumentException($enumerations_SegmentStatusArrayErrorMessage, __LINE__);
        }
        $this->Enumerations_SegmentStatus = $this->{'Enumerations.SegmentStatus'} = $enumerations_SegmentStatus;
        return $this;
    }
    /**
     * Add item to Enumerations_SegmentStatus value
     * @uses \EnumType\Enumerations_SegmentStatus::valueIsValid()
     * @uses \EnumType\Enumerations_SegmentStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \ArrayType\ArrayOfEnumerations_SegmentStatus
     */
    public function addToEnumerations_SegmentStatus($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\Enumerations_SegmentStatus::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\Enumerations_SegmentStatus', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\Enumerations_SegmentStatus::getValidValues())), __LINE__);
        }
        $this->Enumerations_SegmentStatus[] = $this->{'Enumerations.SegmentStatus'}[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \EnumType\Enumerations_SegmentStatus::valueIsValid()
     * @param string $item
     * @return \ArrayType\ArrayOfEnumerations_SegmentStatus
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\EnumType\Enumerations_SegmentStatus::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\Enumerations_SegmentStatus', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \EnumType\Enumerations_SegmentStatus::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Enumerations.SegmentStatus
     */
    public function getAttributeName()
    {
        return 'Enumerations.SegmentStatus';
    }
}
