<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTAContactInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTAContactInfo
 * @subpackage Arrays
 */
class ArrayOfTAContactInfo extends AbstractStructArrayBase
{
    /**
     * The TAContactInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TAContactInfo[]
     */
    public $TAContactInfo;
    /**
     * Constructor method for ArrayOfTAContactInfo
     * @uses ArrayOfTAContactInfo::setTAContactInfo()
     * @param \StructType\TAContactInfo[] $tAContactInfo
     */
    public function __construct(array $tAContactInfo = array())
    {
        $this
            ->setTAContactInfo($tAContactInfo);
    }
    /**
     * Get TAContactInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TAContactInfo[]|null
     */
    public function getTAContactInfo()
    {
        return isset($this->TAContactInfo) ? $this->TAContactInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTAContactInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTAContactInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTAContactInfoForArrayConstraintsFromSetTAContactInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTAContactInfoTAContactInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfTAContactInfoTAContactInfoItem instanceof \StructType\TAContactInfo) {
                $invalidValues[] = is_object($arrayOfTAContactInfoTAContactInfoItem) ? get_class($arrayOfTAContactInfoTAContactInfoItem) : sprintf('%s(%s)', gettype($arrayOfTAContactInfoTAContactInfoItem), var_export($arrayOfTAContactInfoTAContactInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TAContactInfo property can only contain items of type \StructType\TAContactInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TAContactInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TAContactInfo[] $tAContactInfo
     * @return \ArrayType\ArrayOfTAContactInfo
     */
    public function setTAContactInfo(array $tAContactInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($tAContactInfoArrayErrorMessage = self::validateTAContactInfoForArrayConstraintsFromSetTAContactInfo($tAContactInfo))) {
            throw new \InvalidArgumentException($tAContactInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($tAContactInfo) || (is_array($tAContactInfo) && empty($tAContactInfo))) {
            unset($this->TAContactInfo);
        } else {
            $this->TAContactInfo = $tAContactInfo;
        }
        return $this;
    }
    /**
     * Add item to TAContactInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\TAContactInfo $item
     * @return \ArrayType\ArrayOfTAContactInfo
     */
    public function addToTAContactInfo(\StructType\TAContactInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TAContactInfo) {
            throw new \InvalidArgumentException(sprintf('The TAContactInfo property can only contain items of type \StructType\TAContactInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TAContactInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TAContactInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TAContactInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TAContactInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TAContactInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TAContactInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TAContactInfo
     */
    public function getAttributeName()
    {
        return 'TAContactInfo';
    }
}
