<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTopUpDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTopUpDetails
 * @subpackage Arrays
 */
class ArrayOfTopUpDetails extends AbstractStructArrayBase
{
    /**
     * The TopUpDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TopUpDetails[]
     */
    public $TopUpDetails;
    /**
     * Constructor method for ArrayOfTopUpDetails
     * @uses ArrayOfTopUpDetails::setTopUpDetails()
     * @param \StructType\TopUpDetails[] $topUpDetails
     */
    public function __construct(array $topUpDetails = array())
    {
        $this
            ->setTopUpDetails($topUpDetails);
    }
    /**
     * Get TopUpDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TopUpDetails[]|null
     */
    public function getTopUpDetails()
    {
        return isset($this->TopUpDetails) ? $this->TopUpDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTopUpDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTopUpDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTopUpDetailsForArrayConstraintsFromSetTopUpDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTopUpDetailsTopUpDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfTopUpDetailsTopUpDetailsItem instanceof \StructType\TopUpDetails) {
                $invalidValues[] = is_object($arrayOfTopUpDetailsTopUpDetailsItem) ? get_class($arrayOfTopUpDetailsTopUpDetailsItem) : sprintf('%s(%s)', gettype($arrayOfTopUpDetailsTopUpDetailsItem), var_export($arrayOfTopUpDetailsTopUpDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TopUpDetails property can only contain items of type \StructType\TopUpDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TopUpDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TopUpDetails[] $topUpDetails
     * @return \ArrayType\ArrayOfTopUpDetails
     */
    public function setTopUpDetails(array $topUpDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($topUpDetailsArrayErrorMessage = self::validateTopUpDetailsForArrayConstraintsFromSetTopUpDetails($topUpDetails))) {
            throw new \InvalidArgumentException($topUpDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($topUpDetails) || (is_array($topUpDetails) && empty($topUpDetails))) {
            unset($this->TopUpDetails);
        } else {
            $this->TopUpDetails = $topUpDetails;
        }
        return $this;
    }
    /**
     * Add item to TopUpDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\TopUpDetails $item
     * @return \ArrayType\ArrayOfTopUpDetails
     */
    public function addToTopUpDetails(\StructType\TopUpDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TopUpDetails) {
            throw new \InvalidArgumentException(sprintf('The TopUpDetails property can only contain items of type \StructType\TopUpDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TopUpDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TopUpDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TopUpDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TopUpDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TopUpDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TopUpDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TopUpDetails
     */
    public function getAttributeName()
    {
        return 'TopUpDetails';
    }
}
