<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTransactionInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTransactionInfo
 * @subpackage Arrays
 */
class ArrayOfTransactionInfo extends AbstractStructArrayBase
{
    /**
     * The TransactionInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TransactionInfo[]
     */
    public $TransactionInfo;
    /**
     * Constructor method for ArrayOfTransactionInfo
     * @uses ArrayOfTransactionInfo::setTransactionInfo()
     * @param \StructType\TransactionInfo[] $transactionInfo
     */
    public function __construct(array $transactionInfo = array())
    {
        $this
            ->setTransactionInfo($transactionInfo);
    }
    /**
     * Get TransactionInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TransactionInfo[]|null
     */
    public function getTransactionInfo()
    {
        return isset($this->TransactionInfo) ? $this->TransactionInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTransactionInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTransactionInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTransactionInfoForArrayConstraintsFromSetTransactionInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTransactionInfoTransactionInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfTransactionInfoTransactionInfoItem instanceof \StructType\TransactionInfo) {
                $invalidValues[] = is_object($arrayOfTransactionInfoTransactionInfoItem) ? get_class($arrayOfTransactionInfoTransactionInfoItem) : sprintf('%s(%s)', gettype($arrayOfTransactionInfoTransactionInfoItem), var_export($arrayOfTransactionInfoTransactionInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TransactionInfo property can only contain items of type \StructType\TransactionInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TransactionInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TransactionInfo[] $transactionInfo
     * @return \ArrayType\ArrayOfTransactionInfo
     */
    public function setTransactionInfo(array $transactionInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($transactionInfoArrayErrorMessage = self::validateTransactionInfoForArrayConstraintsFromSetTransactionInfo($transactionInfo))) {
            throw new \InvalidArgumentException($transactionInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($transactionInfo) || (is_array($transactionInfo) && empty($transactionInfo))) {
            unset($this->TransactionInfo);
        } else {
            $this->TransactionInfo = $transactionInfo;
        }
        return $this;
    }
    /**
     * Add item to TransactionInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\TransactionInfo $item
     * @return \ArrayType\ArrayOfTransactionInfo
     */
    public function addToTransactionInfo(\StructType\TransactionInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TransactionInfo) {
            throw new \InvalidArgumentException(sprintf('The TransactionInfo property can only contain items of type \StructType\TransactionInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TransactionInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TransactionInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TransactionInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TransactionInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TransactionInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TransactionInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TransactionInfo
     */
    public function getAttributeName()
    {
        return 'TransactionInfo';
    }
}
