<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTravelAgencyCommission ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTravelAgencyCommission
 * @subpackage Arrays
 */
class ArrayOfTravelAgencyCommission extends AbstractStructArrayBase
{
    /**
     * The TravelAgencyCommission
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TravelAgencyCommission[]
     */
    public $TravelAgencyCommission;
    /**
     * Constructor method for ArrayOfTravelAgencyCommission
     * @uses ArrayOfTravelAgencyCommission::setTravelAgencyCommission()
     * @param \StructType\TravelAgencyCommission[] $travelAgencyCommission
     */
    public function __construct(array $travelAgencyCommission = array())
    {
        $this
            ->setTravelAgencyCommission($travelAgencyCommission);
    }
    /**
     * Get TravelAgencyCommission value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TravelAgencyCommission[]|null
     */
    public function getTravelAgencyCommission()
    {
        return isset($this->TravelAgencyCommission) ? $this->TravelAgencyCommission : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTravelAgencyCommission method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTravelAgencyCommission method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTravelAgencyCommissionForArrayConstraintsFromSetTravelAgencyCommission(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTravelAgencyCommissionTravelAgencyCommissionItem) {
            // validation for constraint: itemType
            if (!$arrayOfTravelAgencyCommissionTravelAgencyCommissionItem instanceof \StructType\TravelAgencyCommission) {
                $invalidValues[] = is_object($arrayOfTravelAgencyCommissionTravelAgencyCommissionItem) ? get_class($arrayOfTravelAgencyCommissionTravelAgencyCommissionItem) : sprintf('%s(%s)', gettype($arrayOfTravelAgencyCommissionTravelAgencyCommissionItem), var_export($arrayOfTravelAgencyCommissionTravelAgencyCommissionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TravelAgencyCommission property can only contain items of type \StructType\TravelAgencyCommission, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TravelAgencyCommission value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TravelAgencyCommission[] $travelAgencyCommission
     * @return \ArrayType\ArrayOfTravelAgencyCommission
     */
    public function setTravelAgencyCommission(array $travelAgencyCommission = array())
    {
        // validation for constraint: array
        if ('' !== ($travelAgencyCommissionArrayErrorMessage = self::validateTravelAgencyCommissionForArrayConstraintsFromSetTravelAgencyCommission($travelAgencyCommission))) {
            throw new \InvalidArgumentException($travelAgencyCommissionArrayErrorMessage, __LINE__);
        }
        if (is_null($travelAgencyCommission) || (is_array($travelAgencyCommission) && empty($travelAgencyCommission))) {
            unset($this->TravelAgencyCommission);
        } else {
            $this->TravelAgencyCommission = $travelAgencyCommission;
        }
        return $this;
    }
    /**
     * Add item to TravelAgencyCommission value
     * @throws \InvalidArgumentException
     * @param \StructType\TravelAgencyCommission $item
     * @return \ArrayType\ArrayOfTravelAgencyCommission
     */
    public function addToTravelAgencyCommission(\StructType\TravelAgencyCommission $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TravelAgencyCommission) {
            throw new \InvalidArgumentException(sprintf('The TravelAgencyCommission property can only contain items of type \StructType\TravelAgencyCommission, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TravelAgencyCommission[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TravelAgencyCommission|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TravelAgencyCommission|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TravelAgencyCommission|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TravelAgencyCommission|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TravelAgencyCommission|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TravelAgencyCommission
     */
    public function getAttributeName()
    {
        return 'TravelAgencyCommission';
    }
}
