<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTravelAgencyPNR ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTravelAgencyPNR
 * @subpackage Arrays
 */
class ArrayOfTravelAgencyPNR extends AbstractStructArrayBase
{
    /**
     * The TravelAgencyPNR
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TravelAgencyPNR[]
     */
    public $TravelAgencyPNR;
    /**
     * Constructor method for ArrayOfTravelAgencyPNR
     * @uses ArrayOfTravelAgencyPNR::setTravelAgencyPNR()
     * @param \StructType\TravelAgencyPNR[] $travelAgencyPNR
     */
    public function __construct(array $travelAgencyPNR = array())
    {
        $this
            ->setTravelAgencyPNR($travelAgencyPNR);
    }
    /**
     * Get TravelAgencyPNR value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TravelAgencyPNR[]|null
     */
    public function getTravelAgencyPNR()
    {
        return isset($this->TravelAgencyPNR) ? $this->TravelAgencyPNR : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTravelAgencyPNR method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTravelAgencyPNR method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTravelAgencyPNRForArrayConstraintsFromSetTravelAgencyPNR(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTravelAgencyPNRTravelAgencyPNRItem) {
            // validation for constraint: itemType
            if (!$arrayOfTravelAgencyPNRTravelAgencyPNRItem instanceof \StructType\TravelAgencyPNR) {
                $invalidValues[] = is_object($arrayOfTravelAgencyPNRTravelAgencyPNRItem) ? get_class($arrayOfTravelAgencyPNRTravelAgencyPNRItem) : sprintf('%s(%s)', gettype($arrayOfTravelAgencyPNRTravelAgencyPNRItem), var_export($arrayOfTravelAgencyPNRTravelAgencyPNRItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TravelAgencyPNR property can only contain items of type \StructType\TravelAgencyPNR, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TravelAgencyPNR value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TravelAgencyPNR[] $travelAgencyPNR
     * @return \ArrayType\ArrayOfTravelAgencyPNR
     */
    public function setTravelAgencyPNR(array $travelAgencyPNR = array())
    {
        // validation for constraint: array
        if ('' !== ($travelAgencyPNRArrayErrorMessage = self::validateTravelAgencyPNRForArrayConstraintsFromSetTravelAgencyPNR($travelAgencyPNR))) {
            throw new \InvalidArgumentException($travelAgencyPNRArrayErrorMessage, __LINE__);
        }
        if (is_null($travelAgencyPNR) || (is_array($travelAgencyPNR) && empty($travelAgencyPNR))) {
            unset($this->TravelAgencyPNR);
        } else {
            $this->TravelAgencyPNR = $travelAgencyPNR;
        }
        return $this;
    }
    /**
     * Add item to TravelAgencyPNR value
     * @throws \InvalidArgumentException
     * @param \StructType\TravelAgencyPNR $item
     * @return \ArrayType\ArrayOfTravelAgencyPNR
     */
    public function addToTravelAgencyPNR(\StructType\TravelAgencyPNR $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TravelAgencyPNR) {
            throw new \InvalidArgumentException(sprintf('The TravelAgencyPNR property can only contain items of type \StructType\TravelAgencyPNR, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TravelAgencyPNR[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TravelAgencyPNR|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TravelAgencyPNR|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TravelAgencyPNR|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TravelAgencyPNR|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TravelAgencyPNR|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TravelAgencyPNR
     */
    public function getAttributeName()
    {
        return 'TravelAgencyPNR';
    }
}
