<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewAgencyDetailsItem ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewAgencyDetailsItem
 * @subpackage Arrays
 */
class ArrayOfViewAgencyDetailsItem extends AbstractStructArrayBase
{
    /**
     * The ViewAgencyDetailsItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewAgencyDetailsItem[]
     */
    public $ViewAgencyDetailsItem;
    /**
     * Constructor method for ArrayOfViewAgencyDetailsItem
     * @uses ArrayOfViewAgencyDetailsItem::setViewAgencyDetailsItem()
     * @param \StructType\ViewAgencyDetailsItem[] $viewAgencyDetailsItem
     */
    public function __construct(array $viewAgencyDetailsItem = array())
    {
        $this
            ->setViewAgencyDetailsItem($viewAgencyDetailsItem);
    }
    /**
     * Get ViewAgencyDetailsItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewAgencyDetailsItem[]|null
     */
    public function getViewAgencyDetailsItem()
    {
        return isset($this->ViewAgencyDetailsItem) ? $this->ViewAgencyDetailsItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewAgencyDetailsItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewAgencyDetailsItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewAgencyDetailsItemForArrayConstraintsFromSetViewAgencyDetailsItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewAgencyDetailsItemViewAgencyDetailsItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewAgencyDetailsItemViewAgencyDetailsItemItem instanceof \StructType\ViewAgencyDetailsItem) {
                $invalidValues[] = is_object($arrayOfViewAgencyDetailsItemViewAgencyDetailsItemItem) ? get_class($arrayOfViewAgencyDetailsItemViewAgencyDetailsItemItem) : sprintf('%s(%s)', gettype($arrayOfViewAgencyDetailsItemViewAgencyDetailsItemItem), var_export($arrayOfViewAgencyDetailsItemViewAgencyDetailsItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewAgencyDetailsItem property can only contain items of type \StructType\ViewAgencyDetailsItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewAgencyDetailsItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewAgencyDetailsItem[] $viewAgencyDetailsItem
     * @return \ArrayType\ArrayOfViewAgencyDetailsItem
     */
    public function setViewAgencyDetailsItem(array $viewAgencyDetailsItem = array())
    {
        // validation for constraint: array
        if ('' !== ($viewAgencyDetailsItemArrayErrorMessage = self::validateViewAgencyDetailsItemForArrayConstraintsFromSetViewAgencyDetailsItem($viewAgencyDetailsItem))) {
            throw new \InvalidArgumentException($viewAgencyDetailsItemArrayErrorMessage, __LINE__);
        }
        if (is_null($viewAgencyDetailsItem) || (is_array($viewAgencyDetailsItem) && empty($viewAgencyDetailsItem))) {
            unset($this->ViewAgencyDetailsItem);
        } else {
            $this->ViewAgencyDetailsItem = $viewAgencyDetailsItem;
        }
        return $this;
    }
    /**
     * Add item to ViewAgencyDetailsItem value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewAgencyDetailsItem $item
     * @return \ArrayType\ArrayOfViewAgencyDetailsItem
     */
    public function addToViewAgencyDetailsItem(\StructType\ViewAgencyDetailsItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewAgencyDetailsItem) {
            throw new \InvalidArgumentException(sprintf('The ViewAgencyDetailsItem property can only contain items of type \StructType\ViewAgencyDetailsItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewAgencyDetailsItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewAgencyDetailsItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewAgencyDetailsItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewAgencyDetailsItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewAgencyDetailsItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewAgencyDetailsItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewAgencyDetailsItem
     */
    public function getAttributeName()
    {
        return 'ViewAgencyDetailsItem';
    }
}
