<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewAgencyIncentiveReport ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewAgencyIncentiveReport
 * @subpackage Arrays
 */
class ArrayOfViewAgencyIncentiveReport extends AbstractStructArrayBase
{
    /**
     * The ViewAgencyIncentiveReport
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewAgencyIncentiveReport[]
     */
    public $ViewAgencyIncentiveReport;
    /**
     * Constructor method for ArrayOfViewAgencyIncentiveReport
     * @uses ArrayOfViewAgencyIncentiveReport::setViewAgencyIncentiveReport()
     * @param \StructType\ViewAgencyIncentiveReport[] $viewAgencyIncentiveReport
     */
    public function __construct(array $viewAgencyIncentiveReport = array())
    {
        $this
            ->setViewAgencyIncentiveReport($viewAgencyIncentiveReport);
    }
    /**
     * Get ViewAgencyIncentiveReport value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewAgencyIncentiveReport[]|null
     */
    public function getViewAgencyIncentiveReport()
    {
        return isset($this->ViewAgencyIncentiveReport) ? $this->ViewAgencyIncentiveReport : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewAgencyIncentiveReport method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewAgencyIncentiveReport method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewAgencyIncentiveReportForArrayConstraintsFromSetViewAgencyIncentiveReport(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewAgencyIncentiveReportViewAgencyIncentiveReportItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewAgencyIncentiveReportViewAgencyIncentiveReportItem instanceof \StructType\ViewAgencyIncentiveReport) {
                $invalidValues[] = is_object($arrayOfViewAgencyIncentiveReportViewAgencyIncentiveReportItem) ? get_class($arrayOfViewAgencyIncentiveReportViewAgencyIncentiveReportItem) : sprintf('%s(%s)', gettype($arrayOfViewAgencyIncentiveReportViewAgencyIncentiveReportItem), var_export($arrayOfViewAgencyIncentiveReportViewAgencyIncentiveReportItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewAgencyIncentiveReport property can only contain items of type \StructType\ViewAgencyIncentiveReport, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewAgencyIncentiveReport value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewAgencyIncentiveReport[] $viewAgencyIncentiveReport
     * @return \ArrayType\ArrayOfViewAgencyIncentiveReport
     */
    public function setViewAgencyIncentiveReport(array $viewAgencyIncentiveReport = array())
    {
        // validation for constraint: array
        if ('' !== ($viewAgencyIncentiveReportArrayErrorMessage = self::validateViewAgencyIncentiveReportForArrayConstraintsFromSetViewAgencyIncentiveReport($viewAgencyIncentiveReport))) {
            throw new \InvalidArgumentException($viewAgencyIncentiveReportArrayErrorMessage, __LINE__);
        }
        if (is_null($viewAgencyIncentiveReport) || (is_array($viewAgencyIncentiveReport) && empty($viewAgencyIncentiveReport))) {
            unset($this->ViewAgencyIncentiveReport);
        } else {
            $this->ViewAgencyIncentiveReport = $viewAgencyIncentiveReport;
        }
        return $this;
    }
    /**
     * Add item to ViewAgencyIncentiveReport value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewAgencyIncentiveReport $item
     * @return \ArrayType\ArrayOfViewAgencyIncentiveReport
     */
    public function addToViewAgencyIncentiveReport(\StructType\ViewAgencyIncentiveReport $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewAgencyIncentiveReport) {
            throw new \InvalidArgumentException(sprintf('The ViewAgencyIncentiveReport property can only contain items of type \StructType\ViewAgencyIncentiveReport, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewAgencyIncentiveReport[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewAgencyIncentiveReport|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewAgencyIncentiveReport|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewAgencyIncentiveReport|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewAgencyIncentiveReport|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewAgencyIncentiveReport|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewAgencyIncentiveReport
     */
    public function getAttributeName()
    {
        return 'ViewAgencyIncentiveReport';
    }
}
