<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewAssociateToReservation ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewAssociateToReservation
 * @subpackage Arrays
 */
class ArrayOfViewAssociateToReservation extends AbstractStructArrayBase
{
    /**
     * The ViewAssociateToReservation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewAssociateToReservation[]
     */
    public $ViewAssociateToReservation;
    /**
     * Constructor method for ArrayOfViewAssociateToReservation
     * @uses ArrayOfViewAssociateToReservation::setViewAssociateToReservation()
     * @param \StructType\ViewAssociateToReservation[] $viewAssociateToReservation
     */
    public function __construct(array $viewAssociateToReservation = array())
    {
        $this
            ->setViewAssociateToReservation($viewAssociateToReservation);
    }
    /**
     * Get ViewAssociateToReservation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewAssociateToReservation[]|null
     */
    public function getViewAssociateToReservation()
    {
        return isset($this->ViewAssociateToReservation) ? $this->ViewAssociateToReservation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewAssociateToReservation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewAssociateToReservation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewAssociateToReservationForArrayConstraintsFromSetViewAssociateToReservation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewAssociateToReservationViewAssociateToReservationItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewAssociateToReservationViewAssociateToReservationItem instanceof \StructType\ViewAssociateToReservation) {
                $invalidValues[] = is_object($arrayOfViewAssociateToReservationViewAssociateToReservationItem) ? get_class($arrayOfViewAssociateToReservationViewAssociateToReservationItem) : sprintf('%s(%s)', gettype($arrayOfViewAssociateToReservationViewAssociateToReservationItem), var_export($arrayOfViewAssociateToReservationViewAssociateToReservationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewAssociateToReservation property can only contain items of type \StructType\ViewAssociateToReservation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewAssociateToReservation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewAssociateToReservation[] $viewAssociateToReservation
     * @return \ArrayType\ArrayOfViewAssociateToReservation
     */
    public function setViewAssociateToReservation(array $viewAssociateToReservation = array())
    {
        // validation for constraint: array
        if ('' !== ($viewAssociateToReservationArrayErrorMessage = self::validateViewAssociateToReservationForArrayConstraintsFromSetViewAssociateToReservation($viewAssociateToReservation))) {
            throw new \InvalidArgumentException($viewAssociateToReservationArrayErrorMessage, __LINE__);
        }
        if (is_null($viewAssociateToReservation) || (is_array($viewAssociateToReservation) && empty($viewAssociateToReservation))) {
            unset($this->ViewAssociateToReservation);
        } else {
            $this->ViewAssociateToReservation = $viewAssociateToReservation;
        }
        return $this;
    }
    /**
     * Add item to ViewAssociateToReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewAssociateToReservation $item
     * @return \ArrayType\ArrayOfViewAssociateToReservation
     */
    public function addToViewAssociateToReservation(\StructType\ViewAssociateToReservation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewAssociateToReservation) {
            throw new \InvalidArgumentException(sprintf('The ViewAssociateToReservation property can only contain items of type \StructType\ViewAssociateToReservation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewAssociateToReservation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewAssociateToReservation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewAssociateToReservation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewAssociateToReservation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewAssociateToReservation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewAssociateToReservation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewAssociateToReservation
     */
    public function getAttributeName()
    {
        return 'ViewAssociateToReservation';
    }
}
