<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewBookingHistory ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewBookingHistory
 * @subpackage Arrays
 */
class ArrayOfViewBookingHistory extends AbstractStructArrayBase
{
    /**
     * The ViewBookingHistory
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewBookingHistory[]
     */
    public $ViewBookingHistory;
    /**
     * Constructor method for ArrayOfViewBookingHistory
     * @uses ArrayOfViewBookingHistory::setViewBookingHistory()
     * @param \StructType\ViewBookingHistory[] $viewBookingHistory
     */
    public function __construct(array $viewBookingHistory = array())
    {
        $this
            ->setViewBookingHistory($viewBookingHistory);
    }
    /**
     * Get ViewBookingHistory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewBookingHistory[]|null
     */
    public function getViewBookingHistory()
    {
        return isset($this->ViewBookingHistory) ? $this->ViewBookingHistory : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewBookingHistory method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewBookingHistory method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewBookingHistoryForArrayConstraintsFromSetViewBookingHistory(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewBookingHistoryViewBookingHistoryItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewBookingHistoryViewBookingHistoryItem instanceof \StructType\ViewBookingHistory) {
                $invalidValues[] = is_object($arrayOfViewBookingHistoryViewBookingHistoryItem) ? get_class($arrayOfViewBookingHistoryViewBookingHistoryItem) : sprintf('%s(%s)', gettype($arrayOfViewBookingHistoryViewBookingHistoryItem), var_export($arrayOfViewBookingHistoryViewBookingHistoryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewBookingHistory property can only contain items of type \StructType\ViewBookingHistory, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewBookingHistory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewBookingHistory[] $viewBookingHistory
     * @return \ArrayType\ArrayOfViewBookingHistory
     */
    public function setViewBookingHistory(array $viewBookingHistory = array())
    {
        // validation for constraint: array
        if ('' !== ($viewBookingHistoryArrayErrorMessage = self::validateViewBookingHistoryForArrayConstraintsFromSetViewBookingHistory($viewBookingHistory))) {
            throw new \InvalidArgumentException($viewBookingHistoryArrayErrorMessage, __LINE__);
        }
        if (is_null($viewBookingHistory) || (is_array($viewBookingHistory) && empty($viewBookingHistory))) {
            unset($this->ViewBookingHistory);
        } else {
            $this->ViewBookingHistory = $viewBookingHistory;
        }
        return $this;
    }
    /**
     * Add item to ViewBookingHistory value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewBookingHistory $item
     * @return \ArrayType\ArrayOfViewBookingHistory
     */
    public function addToViewBookingHistory(\StructType\ViewBookingHistory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewBookingHistory) {
            throw new \InvalidArgumentException(sprintf('The ViewBookingHistory property can only contain items of type \StructType\ViewBookingHistory, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewBookingHistory[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewBookingHistory|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewBookingHistory|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewBookingHistory|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewBookingHistory|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewBookingHistory|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewBookingHistory
     */
    public function getAttributeName()
    {
        return 'ViewBookingHistory';
    }
}
