<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewBookingsWithPaymentsPending ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewBookingsWithPaymentsPending
 * @subpackage Arrays
 */
class ArrayOfViewBookingsWithPaymentsPending extends AbstractStructArrayBase
{
    /**
     * The ViewBookingsWithPaymentsPending
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewBookingsWithPaymentsPending[]
     */
    public $ViewBookingsWithPaymentsPending;
    /**
     * Constructor method for ArrayOfViewBookingsWithPaymentsPending
     * @uses ArrayOfViewBookingsWithPaymentsPending::setViewBookingsWithPaymentsPending()
     * @param \StructType\ViewBookingsWithPaymentsPending[] $viewBookingsWithPaymentsPending
     */
    public function __construct(array $viewBookingsWithPaymentsPending = array())
    {
        $this
            ->setViewBookingsWithPaymentsPending($viewBookingsWithPaymentsPending);
    }
    /**
     * Get ViewBookingsWithPaymentsPending value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewBookingsWithPaymentsPending[]|null
     */
    public function getViewBookingsWithPaymentsPending()
    {
        return isset($this->ViewBookingsWithPaymentsPending) ? $this->ViewBookingsWithPaymentsPending : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewBookingsWithPaymentsPending method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewBookingsWithPaymentsPending method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewBookingsWithPaymentsPendingForArrayConstraintsFromSetViewBookingsWithPaymentsPending(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewBookingsWithPaymentsPendingViewBookingsWithPaymentsPendingItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewBookingsWithPaymentsPendingViewBookingsWithPaymentsPendingItem instanceof \StructType\ViewBookingsWithPaymentsPending) {
                $invalidValues[] = is_object($arrayOfViewBookingsWithPaymentsPendingViewBookingsWithPaymentsPendingItem) ? get_class($arrayOfViewBookingsWithPaymentsPendingViewBookingsWithPaymentsPendingItem) : sprintf('%s(%s)', gettype($arrayOfViewBookingsWithPaymentsPendingViewBookingsWithPaymentsPendingItem), var_export($arrayOfViewBookingsWithPaymentsPendingViewBookingsWithPaymentsPendingItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewBookingsWithPaymentsPending property can only contain items of type \StructType\ViewBookingsWithPaymentsPending, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewBookingsWithPaymentsPending value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewBookingsWithPaymentsPending[] $viewBookingsWithPaymentsPending
     * @return \ArrayType\ArrayOfViewBookingsWithPaymentsPending
     */
    public function setViewBookingsWithPaymentsPending(array $viewBookingsWithPaymentsPending = array())
    {
        // validation for constraint: array
        if ('' !== ($viewBookingsWithPaymentsPendingArrayErrorMessage = self::validateViewBookingsWithPaymentsPendingForArrayConstraintsFromSetViewBookingsWithPaymentsPending($viewBookingsWithPaymentsPending))) {
            throw new \InvalidArgumentException($viewBookingsWithPaymentsPendingArrayErrorMessage, __LINE__);
        }
        if (is_null($viewBookingsWithPaymentsPending) || (is_array($viewBookingsWithPaymentsPending) && empty($viewBookingsWithPaymentsPending))) {
            unset($this->ViewBookingsWithPaymentsPending);
        } else {
            $this->ViewBookingsWithPaymentsPending = $viewBookingsWithPaymentsPending;
        }
        return $this;
    }
    /**
     * Add item to ViewBookingsWithPaymentsPending value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewBookingsWithPaymentsPending $item
     * @return \ArrayType\ArrayOfViewBookingsWithPaymentsPending
     */
    public function addToViewBookingsWithPaymentsPending(\StructType\ViewBookingsWithPaymentsPending $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewBookingsWithPaymentsPending) {
            throw new \InvalidArgumentException(sprintf('The ViewBookingsWithPaymentsPending property can only contain items of type \StructType\ViewBookingsWithPaymentsPending, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewBookingsWithPaymentsPending[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewBookingsWithPaymentsPending|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewBookingsWithPaymentsPending|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewBookingsWithPaymentsPending|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewBookingsWithPaymentsPending|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewBookingsWithPaymentsPending|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewBookingsWithPaymentsPending
     */
    public function getAttributeName()
    {
        return 'ViewBookingsWithPaymentsPending';
    }
}
