<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewChangedTAData ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewChangedTAData
 * @subpackage Arrays
 */
class ArrayOfViewChangedTAData extends AbstractStructArrayBase
{
    /**
     * The ViewChangedTAData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewChangedTAData[]
     */
    public $ViewChangedTAData;
    /**
     * Constructor method for ArrayOfViewChangedTAData
     * @uses ArrayOfViewChangedTAData::setViewChangedTAData()
     * @param \StructType\ViewChangedTAData[] $viewChangedTAData
     */
    public function __construct(array $viewChangedTAData = array())
    {
        $this
            ->setViewChangedTAData($viewChangedTAData);
    }
    /**
     * Get ViewChangedTAData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewChangedTAData[]|null
     */
    public function getViewChangedTAData()
    {
        return isset($this->ViewChangedTAData) ? $this->ViewChangedTAData : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewChangedTAData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewChangedTAData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewChangedTADataForArrayConstraintsFromSetViewChangedTAData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewChangedTADataViewChangedTADataItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewChangedTADataViewChangedTADataItem instanceof \StructType\ViewChangedTAData) {
                $invalidValues[] = is_object($arrayOfViewChangedTADataViewChangedTADataItem) ? get_class($arrayOfViewChangedTADataViewChangedTADataItem) : sprintf('%s(%s)', gettype($arrayOfViewChangedTADataViewChangedTADataItem), var_export($arrayOfViewChangedTADataViewChangedTADataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewChangedTAData property can only contain items of type \StructType\ViewChangedTAData, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewChangedTAData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewChangedTAData[] $viewChangedTAData
     * @return \ArrayType\ArrayOfViewChangedTAData
     */
    public function setViewChangedTAData(array $viewChangedTAData = array())
    {
        // validation for constraint: array
        if ('' !== ($viewChangedTADataArrayErrorMessage = self::validateViewChangedTADataForArrayConstraintsFromSetViewChangedTAData($viewChangedTAData))) {
            throw new \InvalidArgumentException($viewChangedTADataArrayErrorMessage, __LINE__);
        }
        if (is_null($viewChangedTAData) || (is_array($viewChangedTAData) && empty($viewChangedTAData))) {
            unset($this->ViewChangedTAData);
        } else {
            $this->ViewChangedTAData = $viewChangedTAData;
        }
        return $this;
    }
    /**
     * Add item to ViewChangedTAData value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewChangedTAData $item
     * @return \ArrayType\ArrayOfViewChangedTAData
     */
    public function addToViewChangedTAData(\StructType\ViewChangedTAData $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewChangedTAData) {
            throw new \InvalidArgumentException(sprintf('The ViewChangedTAData property can only contain items of type \StructType\ViewChangedTAData, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewChangedTAData[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewChangedTAData|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewChangedTAData|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewChangedTAData|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewChangedTAData|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewChangedTAData|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewChangedTAData
     */
    public function getAttributeName()
    {
        return 'ViewChangedTAData';
    }
}
