<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewCreditLimitHistory ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewCreditLimitHistory
 * @subpackage Arrays
 */
class ArrayOfViewCreditLimitHistory extends AbstractStructArrayBase
{
    /**
     * The ViewCreditLimitHistory
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewCreditLimitHistory[]
     */
    public $ViewCreditLimitHistory;
    /**
     * Constructor method for ArrayOfViewCreditLimitHistory
     * @uses ArrayOfViewCreditLimitHistory::setViewCreditLimitHistory()
     * @param \StructType\ViewCreditLimitHistory[] $viewCreditLimitHistory
     */
    public function __construct(array $viewCreditLimitHistory = array())
    {
        $this
            ->setViewCreditLimitHistory($viewCreditLimitHistory);
    }
    /**
     * Get ViewCreditLimitHistory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewCreditLimitHistory[]|null
     */
    public function getViewCreditLimitHistory()
    {
        return isset($this->ViewCreditLimitHistory) ? $this->ViewCreditLimitHistory : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewCreditLimitHistory method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewCreditLimitHistory method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewCreditLimitHistoryForArrayConstraintsFromSetViewCreditLimitHistory(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewCreditLimitHistoryViewCreditLimitHistoryItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewCreditLimitHistoryViewCreditLimitHistoryItem instanceof \StructType\ViewCreditLimitHistory) {
                $invalidValues[] = is_object($arrayOfViewCreditLimitHistoryViewCreditLimitHistoryItem) ? get_class($arrayOfViewCreditLimitHistoryViewCreditLimitHistoryItem) : sprintf('%s(%s)', gettype($arrayOfViewCreditLimitHistoryViewCreditLimitHistoryItem), var_export($arrayOfViewCreditLimitHistoryViewCreditLimitHistoryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewCreditLimitHistory property can only contain items of type \StructType\ViewCreditLimitHistory, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewCreditLimitHistory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewCreditLimitHistory[] $viewCreditLimitHistory
     * @return \ArrayType\ArrayOfViewCreditLimitHistory
     */
    public function setViewCreditLimitHistory(array $viewCreditLimitHistory = array())
    {
        // validation for constraint: array
        if ('' !== ($viewCreditLimitHistoryArrayErrorMessage = self::validateViewCreditLimitHistoryForArrayConstraintsFromSetViewCreditLimitHistory($viewCreditLimitHistory))) {
            throw new \InvalidArgumentException($viewCreditLimitHistoryArrayErrorMessage, __LINE__);
        }
        if (is_null($viewCreditLimitHistory) || (is_array($viewCreditLimitHistory) && empty($viewCreditLimitHistory))) {
            unset($this->ViewCreditLimitHistory);
        } else {
            $this->ViewCreditLimitHistory = $viewCreditLimitHistory;
        }
        return $this;
    }
    /**
     * Add item to ViewCreditLimitHistory value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewCreditLimitHistory $item
     * @return \ArrayType\ArrayOfViewCreditLimitHistory
     */
    public function addToViewCreditLimitHistory(\StructType\ViewCreditLimitHistory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewCreditLimitHistory) {
            throw new \InvalidArgumentException(sprintf('The ViewCreditLimitHistory property can only contain items of type \StructType\ViewCreditLimitHistory, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewCreditLimitHistory[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewCreditLimitHistory|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewCreditLimitHistory|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewCreditLimitHistory|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewCreditLimitHistory|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewCreditLimitHistory|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewCreditLimitHistory
     */
    public function getAttributeName()
    {
        return 'ViewCreditLimitHistory';
    }
}
