<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewCumulativeBalance ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewCumulativeBalance
 * @subpackage Arrays
 */
class ArrayOfViewCumulativeBalance extends AbstractStructArrayBase
{
    /**
     * The ViewCumulativeBalance
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewCumulativeBalance[]
     */
    public $ViewCumulativeBalance;
    /**
     * Constructor method for ArrayOfViewCumulativeBalance
     * @uses ArrayOfViewCumulativeBalance::setViewCumulativeBalance()
     * @param \StructType\ViewCumulativeBalance[] $viewCumulativeBalance
     */
    public function __construct(array $viewCumulativeBalance = array())
    {
        $this
            ->setViewCumulativeBalance($viewCumulativeBalance);
    }
    /**
     * Get ViewCumulativeBalance value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewCumulativeBalance[]|null
     */
    public function getViewCumulativeBalance()
    {
        return isset($this->ViewCumulativeBalance) ? $this->ViewCumulativeBalance : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewCumulativeBalance method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewCumulativeBalance method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewCumulativeBalanceForArrayConstraintsFromSetViewCumulativeBalance(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewCumulativeBalanceViewCumulativeBalanceItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewCumulativeBalanceViewCumulativeBalanceItem instanceof \StructType\ViewCumulativeBalance) {
                $invalidValues[] = is_object($arrayOfViewCumulativeBalanceViewCumulativeBalanceItem) ? get_class($arrayOfViewCumulativeBalanceViewCumulativeBalanceItem) : sprintf('%s(%s)', gettype($arrayOfViewCumulativeBalanceViewCumulativeBalanceItem), var_export($arrayOfViewCumulativeBalanceViewCumulativeBalanceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewCumulativeBalance property can only contain items of type \StructType\ViewCumulativeBalance, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewCumulativeBalance value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewCumulativeBalance[] $viewCumulativeBalance
     * @return \ArrayType\ArrayOfViewCumulativeBalance
     */
    public function setViewCumulativeBalance(array $viewCumulativeBalance = array())
    {
        // validation for constraint: array
        if ('' !== ($viewCumulativeBalanceArrayErrorMessage = self::validateViewCumulativeBalanceForArrayConstraintsFromSetViewCumulativeBalance($viewCumulativeBalance))) {
            throw new \InvalidArgumentException($viewCumulativeBalanceArrayErrorMessage, __LINE__);
        }
        if (is_null($viewCumulativeBalance) || (is_array($viewCumulativeBalance) && empty($viewCumulativeBalance))) {
            unset($this->ViewCumulativeBalance);
        } else {
            $this->ViewCumulativeBalance = $viewCumulativeBalance;
        }
        return $this;
    }
    /**
     * Add item to ViewCumulativeBalance value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewCumulativeBalance $item
     * @return \ArrayType\ArrayOfViewCumulativeBalance
     */
    public function addToViewCumulativeBalance(\StructType\ViewCumulativeBalance $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewCumulativeBalance) {
            throw new \InvalidArgumentException(sprintf('The ViewCumulativeBalance property can only contain items of type \StructType\ViewCumulativeBalance, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewCumulativeBalance[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewCumulativeBalance|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewCumulativeBalance|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewCumulativeBalance|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewCumulativeBalance|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewCumulativeBalance|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewCumulativeBalance
     */
    public function getAttributeName()
    {
        return 'ViewCumulativeBalance';
    }
}
