<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewDisruptedAgencyPNR ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewDisruptedAgencyPNR
 * @subpackage Arrays
 */
class ArrayOfViewDisruptedAgencyPNR extends AbstractStructArrayBase
{
    /**
     * The ViewDisruptedAgencyPNR
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewDisruptedAgencyPNR[]
     */
    public $ViewDisruptedAgencyPNR;
    /**
     * Constructor method for ArrayOfViewDisruptedAgencyPNR
     * @uses ArrayOfViewDisruptedAgencyPNR::setViewDisruptedAgencyPNR()
     * @param \StructType\ViewDisruptedAgencyPNR[] $viewDisruptedAgencyPNR
     */
    public function __construct(array $viewDisruptedAgencyPNR = array())
    {
        $this
            ->setViewDisruptedAgencyPNR($viewDisruptedAgencyPNR);
    }
    /**
     * Get ViewDisruptedAgencyPNR value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewDisruptedAgencyPNR[]|null
     */
    public function getViewDisruptedAgencyPNR()
    {
        return isset($this->ViewDisruptedAgencyPNR) ? $this->ViewDisruptedAgencyPNR : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewDisruptedAgencyPNR method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewDisruptedAgencyPNR method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewDisruptedAgencyPNRForArrayConstraintsFromSetViewDisruptedAgencyPNR(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewDisruptedAgencyPNRViewDisruptedAgencyPNRItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewDisruptedAgencyPNRViewDisruptedAgencyPNRItem instanceof \StructType\ViewDisruptedAgencyPNR) {
                $invalidValues[] = is_object($arrayOfViewDisruptedAgencyPNRViewDisruptedAgencyPNRItem) ? get_class($arrayOfViewDisruptedAgencyPNRViewDisruptedAgencyPNRItem) : sprintf('%s(%s)', gettype($arrayOfViewDisruptedAgencyPNRViewDisruptedAgencyPNRItem), var_export($arrayOfViewDisruptedAgencyPNRViewDisruptedAgencyPNRItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewDisruptedAgencyPNR property can only contain items of type \StructType\ViewDisruptedAgencyPNR, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewDisruptedAgencyPNR value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewDisruptedAgencyPNR[] $viewDisruptedAgencyPNR
     * @return \ArrayType\ArrayOfViewDisruptedAgencyPNR
     */
    public function setViewDisruptedAgencyPNR(array $viewDisruptedAgencyPNR = array())
    {
        // validation for constraint: array
        if ('' !== ($viewDisruptedAgencyPNRArrayErrorMessage = self::validateViewDisruptedAgencyPNRForArrayConstraintsFromSetViewDisruptedAgencyPNR($viewDisruptedAgencyPNR))) {
            throw new \InvalidArgumentException($viewDisruptedAgencyPNRArrayErrorMessage, __LINE__);
        }
        if (is_null($viewDisruptedAgencyPNR) || (is_array($viewDisruptedAgencyPNR) && empty($viewDisruptedAgencyPNR))) {
            unset($this->ViewDisruptedAgencyPNR);
        } else {
            $this->ViewDisruptedAgencyPNR = $viewDisruptedAgencyPNR;
        }
        return $this;
    }
    /**
     * Add item to ViewDisruptedAgencyPNR value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewDisruptedAgencyPNR $item
     * @return \ArrayType\ArrayOfViewDisruptedAgencyPNR
     */
    public function addToViewDisruptedAgencyPNR(\StructType\ViewDisruptedAgencyPNR $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewDisruptedAgencyPNR) {
            throw new \InvalidArgumentException(sprintf('The ViewDisruptedAgencyPNR property can only contain items of type \StructType\ViewDisruptedAgencyPNR, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewDisruptedAgencyPNR[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewDisruptedAgencyPNR|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewDisruptedAgencyPNR|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewDisruptedAgencyPNR|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewDisruptedAgencyPNR|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewDisruptedAgencyPNR|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewDisruptedAgencyPNR
     */
    public function getAttributeName()
    {
        return 'ViewDisruptedAgencyPNR';
    }
}
