<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewDistributorDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewDistributorDetails
 * @subpackage Arrays
 */
class ArrayOfViewDistributorDetails extends AbstractStructArrayBase
{
    /**
     * The ViewDistributorDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewDistributorDetails[]
     */
    public $ViewDistributorDetails;
    /**
     * Constructor method for ArrayOfViewDistributorDetails
     * @uses ArrayOfViewDistributorDetails::setViewDistributorDetails()
     * @param \StructType\ViewDistributorDetails[] $viewDistributorDetails
     */
    public function __construct(array $viewDistributorDetails = array())
    {
        $this
            ->setViewDistributorDetails($viewDistributorDetails);
    }
    /**
     * Get ViewDistributorDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewDistributorDetails[]|null
     */
    public function getViewDistributorDetails()
    {
        return isset($this->ViewDistributorDetails) ? $this->ViewDistributorDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewDistributorDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewDistributorDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewDistributorDetailsForArrayConstraintsFromSetViewDistributorDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewDistributorDetailsViewDistributorDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewDistributorDetailsViewDistributorDetailsItem instanceof \StructType\ViewDistributorDetails) {
                $invalidValues[] = is_object($arrayOfViewDistributorDetailsViewDistributorDetailsItem) ? get_class($arrayOfViewDistributorDetailsViewDistributorDetailsItem) : sprintf('%s(%s)', gettype($arrayOfViewDistributorDetailsViewDistributorDetailsItem), var_export($arrayOfViewDistributorDetailsViewDistributorDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewDistributorDetails property can only contain items of type \StructType\ViewDistributorDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewDistributorDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewDistributorDetails[] $viewDistributorDetails
     * @return \ArrayType\ArrayOfViewDistributorDetails
     */
    public function setViewDistributorDetails(array $viewDistributorDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($viewDistributorDetailsArrayErrorMessage = self::validateViewDistributorDetailsForArrayConstraintsFromSetViewDistributorDetails($viewDistributorDetails))) {
            throw new \InvalidArgumentException($viewDistributorDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($viewDistributorDetails) || (is_array($viewDistributorDetails) && empty($viewDistributorDetails))) {
            unset($this->ViewDistributorDetails);
        } else {
            $this->ViewDistributorDetails = $viewDistributorDetails;
        }
        return $this;
    }
    /**
     * Add item to ViewDistributorDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewDistributorDetails $item
     * @return \ArrayType\ArrayOfViewDistributorDetails
     */
    public function addToViewDistributorDetails(\StructType\ViewDistributorDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewDistributorDetails) {
            throw new \InvalidArgumentException(sprintf('The ViewDistributorDetails property can only contain items of type \StructType\ViewDistributorDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewDistributorDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewDistributorDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewDistributorDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewDistributorDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewDistributorDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewDistributorDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewDistributorDetails
     */
    public function getAttributeName()
    {
        return 'ViewDistributorDetails';
    }
}
