<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewSubAgencies ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewSubAgencies
 * @subpackage Arrays
 */
class ArrayOfViewSubAgencies extends AbstractStructArrayBase
{
    /**
     * The ViewSubAgencies
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewSubAgencies[]
     */
    public $ViewSubAgencies;
    /**
     * Constructor method for ArrayOfViewSubAgencies
     * @uses ArrayOfViewSubAgencies::setViewSubAgencies()
     * @param \StructType\ViewSubAgencies[] $viewSubAgencies
     */
    public function __construct(array $viewSubAgencies = array())
    {
        $this
            ->setViewSubAgencies($viewSubAgencies);
    }
    /**
     * Get ViewSubAgencies value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewSubAgencies[]|null
     */
    public function getViewSubAgencies()
    {
        return isset($this->ViewSubAgencies) ? $this->ViewSubAgencies : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewSubAgencies method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewSubAgencies method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewSubAgenciesForArrayConstraintsFromSetViewSubAgencies(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewSubAgenciesViewSubAgenciesItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewSubAgenciesViewSubAgenciesItem instanceof \StructType\ViewSubAgencies) {
                $invalidValues[] = is_object($arrayOfViewSubAgenciesViewSubAgenciesItem) ? get_class($arrayOfViewSubAgenciesViewSubAgenciesItem) : sprintf('%s(%s)', gettype($arrayOfViewSubAgenciesViewSubAgenciesItem), var_export($arrayOfViewSubAgenciesViewSubAgenciesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewSubAgencies property can only contain items of type \StructType\ViewSubAgencies, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewSubAgencies value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewSubAgencies[] $viewSubAgencies
     * @return \ArrayType\ArrayOfViewSubAgencies
     */
    public function setViewSubAgencies(array $viewSubAgencies = array())
    {
        // validation for constraint: array
        if ('' !== ($viewSubAgenciesArrayErrorMessage = self::validateViewSubAgenciesForArrayConstraintsFromSetViewSubAgencies($viewSubAgencies))) {
            throw new \InvalidArgumentException($viewSubAgenciesArrayErrorMessage, __LINE__);
        }
        if (is_null($viewSubAgencies) || (is_array($viewSubAgencies) && empty($viewSubAgencies))) {
            unset($this->ViewSubAgencies);
        } else {
            $this->ViewSubAgencies = $viewSubAgencies;
        }
        return $this;
    }
    /**
     * Add item to ViewSubAgencies value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewSubAgencies $item
     * @return \ArrayType\ArrayOfViewSubAgencies
     */
    public function addToViewSubAgencies(\StructType\ViewSubAgencies $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewSubAgencies) {
            throw new \InvalidArgumentException(sprintf('The ViewSubAgencies property can only contain items of type \StructType\ViewSubAgencies, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewSubAgencies[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewSubAgencies|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewSubAgencies|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewSubAgencies|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewSubAgencies|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewSubAgencies|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewSubAgencies
     */
    public function getAttributeName()
    {
        return 'ViewSubAgencies';
    }
}
