<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfViewUpdateTopUpDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfViewUpdateTopUpDetails
 * @subpackage Arrays
 */
class ArrayOfViewUpdateTopUpDetails extends AbstractStructArrayBase
{
    /**
     * The ViewUpdateTopUpDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ViewUpdateTopUpDetails[]
     */
    public $ViewUpdateTopUpDetails;
    /**
     * Constructor method for ArrayOfViewUpdateTopUpDetails
     * @uses ArrayOfViewUpdateTopUpDetails::setViewUpdateTopUpDetails()
     * @param \StructType\ViewUpdateTopUpDetails[] $viewUpdateTopUpDetails
     */
    public function __construct(array $viewUpdateTopUpDetails = array())
    {
        $this
            ->setViewUpdateTopUpDetails($viewUpdateTopUpDetails);
    }
    /**
     * Get ViewUpdateTopUpDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ViewUpdateTopUpDetails[]|null
     */
    public function getViewUpdateTopUpDetails()
    {
        return isset($this->ViewUpdateTopUpDetails) ? $this->ViewUpdateTopUpDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setViewUpdateTopUpDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setViewUpdateTopUpDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateViewUpdateTopUpDetailsForArrayConstraintsFromSetViewUpdateTopUpDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfViewUpdateTopUpDetailsViewUpdateTopUpDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfViewUpdateTopUpDetailsViewUpdateTopUpDetailsItem instanceof \StructType\ViewUpdateTopUpDetails) {
                $invalidValues[] = is_object($arrayOfViewUpdateTopUpDetailsViewUpdateTopUpDetailsItem) ? get_class($arrayOfViewUpdateTopUpDetailsViewUpdateTopUpDetailsItem) : sprintf('%s(%s)', gettype($arrayOfViewUpdateTopUpDetailsViewUpdateTopUpDetailsItem), var_export($arrayOfViewUpdateTopUpDetailsViewUpdateTopUpDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ViewUpdateTopUpDetails property can only contain items of type \StructType\ViewUpdateTopUpDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ViewUpdateTopUpDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ViewUpdateTopUpDetails[] $viewUpdateTopUpDetails
     * @return \ArrayType\ArrayOfViewUpdateTopUpDetails
     */
    public function setViewUpdateTopUpDetails(array $viewUpdateTopUpDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($viewUpdateTopUpDetailsArrayErrorMessage = self::validateViewUpdateTopUpDetailsForArrayConstraintsFromSetViewUpdateTopUpDetails($viewUpdateTopUpDetails))) {
            throw new \InvalidArgumentException($viewUpdateTopUpDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($viewUpdateTopUpDetails) || (is_array($viewUpdateTopUpDetails) && empty($viewUpdateTopUpDetails))) {
            unset($this->ViewUpdateTopUpDetails);
        } else {
            $this->ViewUpdateTopUpDetails = $viewUpdateTopUpDetails;
        }
        return $this;
    }
    /**
     * Add item to ViewUpdateTopUpDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\ViewUpdateTopUpDetails $item
     * @return \ArrayType\ArrayOfViewUpdateTopUpDetails
     */
    public function addToViewUpdateTopUpDetails(\StructType\ViewUpdateTopUpDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ViewUpdateTopUpDetails) {
            throw new \InvalidArgumentException(sprintf('The ViewUpdateTopUpDetails property can only contain items of type \StructType\ViewUpdateTopUpDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ViewUpdateTopUpDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ViewUpdateTopUpDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ViewUpdateTopUpDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ViewUpdateTopUpDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ViewUpdateTopUpDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ViewUpdateTopUpDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ViewUpdateTopUpDetails
     */
    public function getAttributeName()
    {
        return 'ViewUpdateTopUpDetails';
    }
}
