<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'RetrieveAgencyDetails' => '\\StructType\\RetrieveAgencyDetails',
            'RetrieveAgencyDetailsResponse' => '\\StructType\\RetrieveAgencyDetailsResponse',
            'LoginTravelAgent' => '\\StructType\\LoginTravelAgent',
            'LoginTravelAgentResponse' => '\\StructType\\LoginTravelAgentResponse',
            'RetrieveAvailableCredit' => '\\StructType\\RetrieveAvailableCredit',
            'RetrieveAvailableCreditResponse' => '\\StructType\\RetrieveAvailableCreditResponse',
            'RetrieveAvailableAgencyCredit' => '\\StructType\\RetrieveAvailableAgencyCredit',
            'RetrieveAvailableAgencyCreditResponse' => '\\StructType\\RetrieveAvailableAgencyCreditResponse',
            'RetrieveTravelAgencyPNRList' => '\\StructType\\RetrieveTravelAgencyPNRList',
            'RetrieveTravelAgencyPNRListResponse' => '\\StructType\\RetrieveTravelAgencyPNRListResponse',
            'RetrieveAgencyCommission' => '\\StructType\\RetrieveAgencyCommission',
            'RetrieveAgencyCommissionResponse' => '\\StructType\\RetrieveAgencyCommissionResponse',
            'RetrieveAgencyInfo' => '\\StructType\\RetrieveAgencyInfo',
            'RetrieveAgencyInfoResponse' => '\\StructType\\RetrieveAgencyInfoResponse',
            'RetrieveAgencyList' => '\\StructType\\RetrieveAgencyList',
            'RetrieveAgencyListResponse' => '\\StructType\\RetrieveAgencyListResponse',
            'RetrieveAgentList' => '\\StructType\\RetrieveAgentList',
            'RetrieveAgentListResponse' => '\\StructType\\RetrieveAgentListResponse',
            'ModifyAgencyCreditLimit' => '\\StructType\\ModifyAgencyCreditLimit',
            'ModifyAgencyCreditLimitResponse' => '\\StructType\\ModifyAgencyCreditLimitResponse',
            'RetrieveDisruptedAgencyPNRList' => '\\StructType\\RetrieveDisruptedAgencyPNRList',
            'RetrieveDisruptedAgencyPNRListResponse' => '\\StructType\\RetrieveDisruptedAgencyPNRListResponse',
            'RetrieveAgencywithCCInfo' => '\\StructType\\RetrieveAgencywithCCInfo',
            'RetrieveAgencywithCCInfoResponse' => '\\StructType\\RetrieveAgencywithCCInfoResponse',
            'RetrieveAgentDetails' => '\\StructType\\RetrieveAgentDetails',
            'RetrieveAgentDetailsResponse' => '\\StructType\\RetrieveAgentDetailsResponse',
            'RetrieveCommissionDashboardInfo' => '\\StructType\\RetrieveCommissionDashboardInfo',
            'RetrieveCommissionDashboardInfoResponse' => '\\StructType\\RetrieveCommissionDashboardInfoResponse',
            'RetrieveTransactionDashboardInfo' => '\\StructType\\RetrieveTransactionDashboardInfo',
            'RetrieveTransactionDashboardInfoResponse' => '\\StructType\\RetrieveTransactionDashboardInfoResponse',
            'RetrieveBalanceDashboardInfo' => '\\StructType\\RetrieveBalanceDashboardInfo',
            'RetrieveBalanceDashboardInfoResponse' => '\\StructType\\RetrieveBalanceDashboardInfoResponse',
            'CreateAgency' => '\\StructType\\CreateAgency',
            'CreateAgencyResponse' => '\\StructType\\CreateAgencyResponse',
            'ModifyAgency' => '\\StructType\\ModifyAgency',
            'ModifyAgencyResponse' => '\\StructType\\ModifyAgencyResponse',
            'CreateAgent' => '\\StructType\\CreateAgent',
            'CreateAgentResponse' => '\\StructType\\CreateAgentResponse',
            'ModifyAgent' => '\\StructType\\ModifyAgent',
            'ModifyAgentResponse' => '\\StructType\\ModifyAgentResponse',
            'MoveAgencySessionDataToNewSecurityToken' => '\\StructType\\MoveAgencySessionDataToNewSecurityToken',
            'MoveAgencySessionDataToNewSecurityTokenResponse' => '\\StructType\\MoveAgencySessionDataToNewSecurityTokenResponse',
            'RetrieveBookingHistory' => '\\StructType\\RetrieveBookingHistory',
            'RetrieveBookingHistoryResponse' => '\\StructType\\RetrieveBookingHistoryResponse',
            'RetrieveCumulativeBalance' => '\\StructType\\RetrieveCumulativeBalance',
            'RetrieveCumulativeBalanceResponse' => '\\StructType\\RetrieveCumulativeBalanceResponse',
            'RetrieveCreditLimitHistory' => '\\StructType\\RetrieveCreditLimitHistory',
            'RetrieveCreditLimitHistoryResponse' => '\\StructType\\RetrieveCreditLimitHistoryResponse',
            'RetrieveFinanceAgents' => '\\StructType\\RetrieveFinanceAgents',
            'RetrieveFinanceAgentsResponse' => '\\StructType\\RetrieveFinanceAgentsResponse',
            'RetrieveSubAgencies' => '\\StructType\\RetrieveSubAgencies',
            'RetrieveSubAgenciesResponse' => '\\StructType\\RetrieveSubAgenciesResponse',
            'RetrieveDistributorDetails' => '\\StructType\\RetrieveDistributorDetails',
            'RetrieveDistributorDetailsResponse' => '\\StructType\\RetrieveDistributorDetailsResponse',
            'AssociateToReservation' => '\\StructType\\AssociateToReservation',
            'AssociateToReservationResponse' => '\\StructType\\AssociateToReservationResponse',
            'RetrieveChangedTAData' => '\\StructType\\RetrieveChangedTAData',
            'RetrieveChangedTADataResponse' => '\\StructType\\RetrieveChangedTADataResponse',
            'RetrieveAgencyIncentiveReport' => '\\StructType\\RetrieveAgencyIncentiveReport',
            'RetrieveAgencyIncentiveReportResponse' => '\\StructType\\RetrieveAgencyIncentiveReportResponse',
            'RetrieveAgencyPNR' => '\\StructType\\RetrieveAgencyPNR',
            'RetrieveAgencyPNRResponse' => '\\StructType\\RetrieveAgencyPNRResponse',
            'RetrieveBookingsWithPaymentsPending' => '\\StructType\\RetrieveBookingsWithPaymentsPending',
            'RetrieveBookingsWithPaymentsPendingResponse' => '\\StructType\\RetrieveBookingsWithPaymentsPendingResponse',
            'UpdateTopUpDetails' => '\\StructType\\UpdateTopUpDetails',
            'UpdateTopUpDetailsResponse' => '\\StructType\\UpdateTopUpDetailsResponse',
            'LoginTravelAgentSingleSignOn' => '\\StructType\\LoginTravelAgentSingleSignOn',
            'LoginTravelAgentSingleSignOnResponse' => '\\StructType\\LoginTravelAgentSingleSignOnResponse',
            'AgencyFundsTransfer' => '\\StructType\\AgencyFundsTransfer',
            'AgencyFundsTransferResponse' => '\\StructType\\AgencyFundsTransferResponse',
            'ArrayOfTAContactInfo' => '\\ArrayType\\ArrayOfTAContactInfo',
            'TAContactInfo' => '\\StructType\\TAContactInfo',
            'ArrayOfChargeCode' => '\\ArrayType\\ArrayOfChargeCode',
            'ChargeCode' => '\\StructType\\ChargeCode',
            'ArrayOfTopUpDetails' => '\\ArrayType\\ArrayOfTopUpDetails',
            'TopUpDetails' => '\\StructType\\TopUpDetails',
            'TransactionInfo' => '\\StructType\\TransactionInfo',
            'ArrayOfCarrierCode' => '\\ArrayType\\ArrayOfCarrierCode',
            'CarrierCode' => '\\StructType\\CarrierCode',
            'AgencyInfo' => '\\StructType\\AgencyInfo',
            'ArrayOfEnumerations.AgencyFields' => '\\ArrayType\\ArrayOfEnumerations_AgencyFields',
            'ArrayOfEnumerations.SegmentStatus' => '\\ArrayType\\ArrayOfEnumerations_SegmentStatus',
            'ViewAgencyDetails' => '\\StructType\\ViewAgencyDetails',
            'ArrayOfViewAgencyDetailsItem' => '\\ArrayType\\ArrayOfViewAgencyDetailsItem',
            'ViewAgencyDetailsItem' => '\\StructType\\ViewAgencyDetailsItem',
            'LoginTravelAgentStatus' => '\\StructType\\LoginTravelAgentStatus',
            'ViewAvailableCredit' => '\\StructType\\ViewAvailableCredit',
            'ViewTravelAgencyPNRList' => '\\StructType\\ViewTravelAgencyPNRList',
            'ArrayOfTravelAgencyPNR' => '\\ArrayType\\ArrayOfTravelAgencyPNR',
            'TravelAgencyPNR' => '\\StructType\\TravelAgencyPNR',
            'ArrayOfPassenger' => '\\ArrayType\\ArrayOfPassenger',
            'Passenger' => '\\StructType\\Passenger',
            'ViewAgencyCommission' => '\\StructType\\ViewAgencyCommission',
            'ArrayOfTravelAgencyCommission' => '\\ArrayType\\ArrayOfTravelAgencyCommission',
            'TravelAgencyCommission' => '\\StructType\\TravelAgencyCommission',
            'ViewAgencyInfo' => '\\StructType\\ViewAgencyInfo',
            'ViewAgencyList' => '\\StructType\\ViewAgencyList',
            'ArrayOfViewAgencyListItem' => '\\ArrayType\\ArrayOfViewAgencyListItem',
            'ViewAgencyListItem' => '\\StructType\\ViewAgencyListItem',
            'ViewAgentList' => '\\StructType\\ViewAgentList',
            'ArrayOfViewAgent' => '\\ArrayType\\ArrayOfViewAgent',
            'ViewAgent' => '\\StructType\\ViewAgent',
            'ViewModifyAgencyCreditLimit' => '\\StructType\\ViewModifyAgencyCreditLimit',
            'ViewDisruptedAgencyPNRList' => '\\StructType\\ViewDisruptedAgencyPNRList',
            'ArrayOfViewDisruptedAgencyPNR' => '\\ArrayType\\ArrayOfViewDisruptedAgencyPNR',
            'ViewDisruptedAgencyPNR' => '\\StructType\\ViewDisruptedAgencyPNR',
            'ViewAgencywithCCInfo' => '\\StructType\\ViewAgencywithCCInfo',
            'ArrayOfAgencyCreditCardInfo' => '\\ArrayType\\ArrayOfAgencyCreditCardInfo',
            'AgencyCreditCardInfo' => '\\StructType\\AgencyCreditCardInfo',
            'ViewAgentDetails' => '\\StructType\\ViewAgentDetails',
            'ViewBookingHistoryCollection' => '\\StructType\\ViewBookingHistoryCollection',
            'ArrayOfViewBookingHistory' => '\\ArrayType\\ArrayOfViewBookingHistory',
            'ViewBookingHistory' => '\\StructType\\ViewBookingHistory',
            'ViewCumulativeBalanceCollection' => '\\StructType\\ViewCumulativeBalanceCollection',
            'ArrayOfViewCumulativeBalance' => '\\ArrayType\\ArrayOfViewCumulativeBalance',
            'ViewCumulativeBalance' => '\\StructType\\ViewCumulativeBalance',
            'ViewCreditLimitHistoryCollection' => '\\StructType\\ViewCreditLimitHistoryCollection',
            'ArrayOfViewCreditLimitHistory' => '\\ArrayType\\ArrayOfViewCreditLimitHistory',
            'ViewCreditLimitHistory' => '\\StructType\\ViewCreditLimitHistory',
            'ViewFinanceAgentsCollection' => '\\StructType\\ViewFinanceAgentsCollection',
            'ArrayOfViewFinanceAgents' => '\\ArrayType\\ArrayOfViewFinanceAgents',
            'ViewFinanceAgents' => '\\StructType\\ViewFinanceAgents',
            'ViewSubAgenciesCollection' => '\\StructType\\ViewSubAgenciesCollection',
            'ArrayOfViewSubAgencies' => '\\ArrayType\\ArrayOfViewSubAgencies',
            'ViewSubAgencies' => '\\StructType\\ViewSubAgencies',
            'ViewDistributorDetailsCollection' => '\\StructType\\ViewDistributorDetailsCollection',
            'ArrayOfViewDistributorDetails' => '\\ArrayType\\ArrayOfViewDistributorDetails',
            'ViewDistributorDetails' => '\\StructType\\ViewDistributorDetails',
            'ViewAssociateToReservationCollection' => '\\StructType\\ViewAssociateToReservationCollection',
            'ArrayOfViewAssociateToReservation' => '\\ArrayType\\ArrayOfViewAssociateToReservation',
            'ViewAssociateToReservation' => '\\StructType\\ViewAssociateToReservation',
            'ViewChangedTADataCollection' => '\\StructType\\ViewChangedTADataCollection',
            'ArrayOfViewChangedTAData' => '\\ArrayType\\ArrayOfViewChangedTAData',
            'ViewChangedTAData' => '\\StructType\\ViewChangedTAData',
            'ViewAgencyIncentiveReportCollection' => '\\StructType\\ViewAgencyIncentiveReportCollection',
            'ArrayOfViewAgencyIncentiveReport' => '\\ArrayType\\ArrayOfViewAgencyIncentiveReport',
            'ViewAgencyIncentiveReport' => '\\StructType\\ViewAgencyIncentiveReport',
            'ViewAgencyPNRCollection' => '\\StructType\\ViewAgencyPNRCollection',
            'ArrayOfAgencyPNR' => '\\ArrayType\\ArrayOfAgencyPNR',
            'AgencyPNR' => '\\StructType\\AgencyPNR',
            'ViewBookingsWithPaymentsPendingCollection' => '\\StructType\\ViewBookingsWithPaymentsPendingCollection',
            'ArrayOfViewBookingsWithPaymentsPending' => '\\ArrayType\\ArrayOfViewBookingsWithPaymentsPending',
            'ViewBookingsWithPaymentsPending' => '\\StructType\\ViewBookingsWithPaymentsPending',
            'ViewUpdateTopUpDetailsColletion' => '\\StructType\\ViewUpdateTopUpDetailsColletion',
            'ArrayOfViewUpdateTopUpDetails' => '\\ArrayType\\ArrayOfViewUpdateTopUpDetails',
            'ViewUpdateTopUpDetails' => '\\StructType\\ViewUpdateTopUpDetails',
            'LoginTravelAgentStatusAndType' => '\\StructType\\LoginTravelAgentStatusAndType',
            'AgencyFundsTransferStatus' => '\\StructType\\AgencyFundsTransferStatus',
            'ExceptionInformation.Exceptions' => '\\StructType\\ExceptionInformation_Exceptions',
            'ExceptionInformation.Exception' => '\\StructType\\ExceptionInformation_Exception',
            'DashboardViewInfo' => '\\StructType\\DashboardViewInfo',
            'ViewCommissionInfo' => '\\StructType\\ViewCommissionInfo',
            'ArrayOfCommissionInfo' => '\\ArrayType\\ArrayOfCommissionInfo',
            'CommissionInfo' => '\\StructType\\CommissionInfo',
            'ViewTransactionInfo' => '\\StructType\\ViewTransactionInfo',
            'ArrayOfTransactionInfo' => '\\ArrayType\\ArrayOfTransactionInfo',
            'ViewBalanceInfo' => '\\StructType\\ViewBalanceInfo',
            'ArrayOfBalanceInfo' => '\\ArrayType\\ArrayOfBalanceInfo',
            'BalanceInfo' => '\\StructType\\BalanceInfo',
        );
    }
}
