<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LoginTravelAgentStatusAndType StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:LoginTravelAgentStatusAndType
 * @subpackage Structs
 */
class LoginTravelAgentStatusAndType extends AbstractStructBase
{
    /**
     * The LoggedIn
     * @var bool
     */
    public $LoggedIn;
    /**
     * The TravelAgentType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TravelAgentType;
    /**
     * The Exceptions
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\ExceptionInformation_Exceptions
     */
    public $Exceptions;
    /**
     * Constructor method for LoginTravelAgentStatusAndType
     * @uses LoginTravelAgentStatusAndType::setLoggedIn()
     * @uses LoginTravelAgentStatusAndType::setTravelAgentType()
     * @uses LoginTravelAgentStatusAndType::setExceptions()
     * @param bool $loggedIn
     * @param string $travelAgentType
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     */
    public function __construct($loggedIn = null, $travelAgentType = null, \StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        $this
            ->setLoggedIn($loggedIn)
            ->setTravelAgentType($travelAgentType)
            ->setExceptions($exceptions);
    }
    /**
     * Get LoggedIn value
     * @return bool|null
     */
    public function getLoggedIn()
    {
        return $this->LoggedIn;
    }
    /**
     * Set LoggedIn value
     * @param bool $loggedIn
     * @return \StructType\LoginTravelAgentStatusAndType
     */
    public function setLoggedIn($loggedIn = null)
    {
        // validation for constraint: boolean
        if (!is_null($loggedIn) && !is_bool($loggedIn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($loggedIn, true), gettype($loggedIn)), __LINE__);
        }
        $this->LoggedIn = $loggedIn;
        return $this;
    }
    /**
     * Get TravelAgentType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTravelAgentType()
    {
        return isset($this->TravelAgentType) ? $this->TravelAgentType : null;
    }
    /**
     * Set TravelAgentType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $travelAgentType
     * @return \StructType\LoginTravelAgentStatusAndType
     */
    public function setTravelAgentType($travelAgentType = null)
    {
        // validation for constraint: string
        if (!is_null($travelAgentType) && !is_string($travelAgentType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($travelAgentType, true), gettype($travelAgentType)), __LINE__);
        }
        if (is_null($travelAgentType) || (is_array($travelAgentType) && empty($travelAgentType))) {
            unset($this->TravelAgentType);
        } else {
            $this->TravelAgentType = $travelAgentType;
        }
        return $this;
    }
    /**
     * Get Exceptions value
     * @return \StructType\ExceptionInformation_Exceptions|null
     */
    public function getExceptions()
    {
        return $this->Exceptions;
    }
    /**
     * Set Exceptions value
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     * @return \StructType\LoginTravelAgentStatusAndType
     */
    public function setExceptions(\StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        $this->Exceptions = $exceptions;
        return $this;
    }
}
