<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MoveAgencySessionDataToNewSecurityToken StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:MoveAgencySessionDataToNewSecurityToken
 * @subpackage Structs
 */
class MoveAgencySessionDataToNewSecurityToken extends TransactionInfo
{
    /**
     * The MoveAgencySessionDataToNewSecurityTokenRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MoveAgencySessionDataToNewSecurityToken
     */
    public $MoveAgencySessionDataToNewSecurityTokenRequest;
    /**
     * The NewSecurityToken
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $NewSecurityToken;
    /**
     * The Exceptions
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\ExceptionInformation_Exceptions
     */
    public $Exceptions;
    /**
     * Constructor method for MoveAgencySessionDataToNewSecurityToken
     * @uses MoveAgencySessionDataToNewSecurityToken::setMoveAgencySessionDataToNewSecurityTokenRequest()
     * @uses MoveAgencySessionDataToNewSecurityToken::setNewSecurityToken()
     * @uses MoveAgencySessionDataToNewSecurityToken::setExceptions()
     * @param \StructType\MoveAgencySessionDataToNewSecurityToken $moveAgencySessionDataToNewSecurityTokenRequest
     * @param string $newSecurityToken
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     */
    public function __construct(\StructType\MoveAgencySessionDataToNewSecurityToken $moveAgencySessionDataToNewSecurityTokenRequest = null, $newSecurityToken = null, \StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        $this
            ->setMoveAgencySessionDataToNewSecurityTokenRequest($moveAgencySessionDataToNewSecurityTokenRequest)
            ->setNewSecurityToken($newSecurityToken)
            ->setExceptions($exceptions);
    }
    /**
     * Get MoveAgencySessionDataToNewSecurityTokenRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MoveAgencySessionDataToNewSecurityToken|null
     */
    public function getMoveAgencySessionDataToNewSecurityTokenRequest()
    {
        return isset($this->MoveAgencySessionDataToNewSecurityTokenRequest) ? $this->MoveAgencySessionDataToNewSecurityTokenRequest : null;
    }
    /**
     * Set MoveAgencySessionDataToNewSecurityTokenRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\MoveAgencySessionDataToNewSecurityToken $moveAgencySessionDataToNewSecurityTokenRequest
     * @return \StructType\MoveAgencySessionDataToNewSecurityToken
     */
    public function setMoveAgencySessionDataToNewSecurityTokenRequest(\StructType\MoveAgencySessionDataToNewSecurityToken $moveAgencySessionDataToNewSecurityTokenRequest = null)
    {
        if (is_null($moveAgencySessionDataToNewSecurityTokenRequest) || (is_array($moveAgencySessionDataToNewSecurityTokenRequest) && empty($moveAgencySessionDataToNewSecurityTokenRequest))) {
            unset($this->MoveAgencySessionDataToNewSecurityTokenRequest);
        } else {
            $this->MoveAgencySessionDataToNewSecurityTokenRequest = $moveAgencySessionDataToNewSecurityTokenRequest;
        }
        return $this;
    }
    /**
     * Get NewSecurityToken value
     * @return string|null
     */
    public function getNewSecurityToken()
    {
        return $this->NewSecurityToken;
    }
    /**
     * Set NewSecurityToken value
     * @param string $newSecurityToken
     * @return \StructType\MoveAgencySessionDataToNewSecurityToken
     */
    public function setNewSecurityToken($newSecurityToken = null)
    {
        // validation for constraint: string
        if (!is_null($newSecurityToken) && !is_string($newSecurityToken)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($newSecurityToken, true), gettype($newSecurityToken)), __LINE__);
        }
        $this->NewSecurityToken = $newSecurityToken;
        return $this;
    }
    /**
     * Get Exceptions value
     * @return \StructType\ExceptionInformation_Exceptions|null
     */
    public function getExceptions()
    {
        return $this->Exceptions;
    }
    /**
     * Set Exceptions value
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     * @return \StructType\MoveAgencySessionDataToNewSecurityToken
     */
    public function setExceptions(\StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        $this->Exceptions = $exceptions;
        return $this;
    }
}
