<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RetrieveDistributorDetails StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:RetrieveDistributorDetails
 * @subpackage Structs
 */
class RetrieveDistributorDetails extends TransactionInfo
{
    /**
     * The RetrieveDistributorDetailsRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RetrieveDistributorDetails
     */
    public $RetrieveDistributorDetailsRequest;
    /**
     * The UpdatedDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $UpdatedDate;
    /**
     * Constructor method for RetrieveDistributorDetails
     * @uses RetrieveDistributorDetails::setRetrieveDistributorDetailsRequest()
     * @uses RetrieveDistributorDetails::setUpdatedDate()
     * @param \StructType\RetrieveDistributorDetails $retrieveDistributorDetailsRequest
     * @param string $updatedDate
     */
    public function __construct(\StructType\RetrieveDistributorDetails $retrieveDistributorDetailsRequest = null, $updatedDate = null)
    {
        $this
            ->setRetrieveDistributorDetailsRequest($retrieveDistributorDetailsRequest)
            ->setUpdatedDate($updatedDate);
    }
    /**
     * Get RetrieveDistributorDetailsRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RetrieveDistributorDetails|null
     */
    public function getRetrieveDistributorDetailsRequest()
    {
        return isset($this->RetrieveDistributorDetailsRequest) ? $this->RetrieveDistributorDetailsRequest : null;
    }
    /**
     * Set RetrieveDistributorDetailsRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\RetrieveDistributorDetails $retrieveDistributorDetailsRequest
     * @return \StructType\RetrieveDistributorDetails
     */
    public function setRetrieveDistributorDetailsRequest(\StructType\RetrieveDistributorDetails $retrieveDistributorDetailsRequest = null)
    {
        if (is_null($retrieveDistributorDetailsRequest) || (is_array($retrieveDistributorDetailsRequest) && empty($retrieveDistributorDetailsRequest))) {
            unset($this->RetrieveDistributorDetailsRequest);
        } else {
            $this->RetrieveDistributorDetailsRequest = $retrieveDistributorDetailsRequest;
        }
        return $this;
    }
    /**
     * Get UpdatedDate value
     * @return string|null
     */
    public function getUpdatedDate()
    {
        return $this->UpdatedDate;
    }
    /**
     * Set UpdatedDate value
     * @param string $updatedDate
     * @return \StructType\RetrieveDistributorDetails
     */
    public function setUpdatedDate($updatedDate = null)
    {
        // validation for constraint: string
        if (!is_null($updatedDate) && !is_string($updatedDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($updatedDate, true), gettype($updatedDate)), __LINE__);
        }
        $this->UpdatedDate = $updatedDate;
        return $this;
    }
}
