<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ViewChangedTAData StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ViewChangedTAData
 * @subpackage Structs
 */
class ViewChangedTAData extends AbstractStructBase
{
    /**
     * The AgencyCompany
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $AgencyCompany;
    /**
     * The AgencyEmail
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $AgencyEmail;
    /**
     * The AgencyAddress1
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $AgencyAddress1;
    /**
     * The AgencyAddress2
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $AgencyAddress2;
    /**
     * The AgencyCity
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $AgencyCity;
    /**
     * The AgencyCountry
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $AgencyCountry;
    /**
     * The AgencyIATA
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $AgencyIATA;
    /**
     * The AgencyParentalIATA
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $AgencyParentalIATA;
    /**
     * The AgencyPhoneNumber
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $AgencyPhoneNumber;
    /**
     * The AgencyFaxNumber
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $AgencyFaxNumber;
    /**
     * The AgencyFieldChangedDate
     * @var string
     */
    public $AgencyFieldChangedDate;
    /**
     * The ChangedFields
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \ArrayType\ArrayOfEnumerations_AgencyFields
     */
    public $ChangedFields;
    /**
     * Constructor method for ViewChangedTAData
     * @uses ViewChangedTAData::setAgencyCompany()
     * @uses ViewChangedTAData::setAgencyEmail()
     * @uses ViewChangedTAData::setAgencyAddress1()
     * @uses ViewChangedTAData::setAgencyAddress2()
     * @uses ViewChangedTAData::setAgencyCity()
     * @uses ViewChangedTAData::setAgencyCountry()
     * @uses ViewChangedTAData::setAgencyIATA()
     * @uses ViewChangedTAData::setAgencyParentalIATA()
     * @uses ViewChangedTAData::setAgencyPhoneNumber()
     * @uses ViewChangedTAData::setAgencyFaxNumber()
     * @uses ViewChangedTAData::setAgencyFieldChangedDate()
     * @uses ViewChangedTAData::setChangedFields()
     * @param string $agencyCompany
     * @param string $agencyEmail
     * @param string $agencyAddress1
     * @param string $agencyAddress2
     * @param string $agencyCity
     * @param string $agencyCountry
     * @param string $agencyIATA
     * @param string $agencyParentalIATA
     * @param string $agencyPhoneNumber
     * @param string $agencyFaxNumber
     * @param string $agencyFieldChangedDate
     * @param \ArrayType\ArrayOfEnumerations_AgencyFields $changedFields
     */
    public function __construct($agencyCompany = null, $agencyEmail = null, $agencyAddress1 = null, $agencyAddress2 = null, $agencyCity = null, $agencyCountry = null, $agencyIATA = null, $agencyParentalIATA = null, $agencyPhoneNumber = null, $agencyFaxNumber = null, $agencyFieldChangedDate = null, \ArrayType\ArrayOfEnumerations_AgencyFields $changedFields = null)
    {
        $this
            ->setAgencyCompany($agencyCompany)
            ->setAgencyEmail($agencyEmail)
            ->setAgencyAddress1($agencyAddress1)
            ->setAgencyAddress2($agencyAddress2)
            ->setAgencyCity($agencyCity)
            ->setAgencyCountry($agencyCountry)
            ->setAgencyIATA($agencyIATA)
            ->setAgencyParentalIATA($agencyParentalIATA)
            ->setAgencyPhoneNumber($agencyPhoneNumber)
            ->setAgencyFaxNumber($agencyFaxNumber)
            ->setAgencyFieldChangedDate($agencyFieldChangedDate)
            ->setChangedFields($changedFields);
    }
    /**
     * Get AgencyCompany value
     * @return string|null
     */
    public function getAgencyCompany()
    {
        return $this->AgencyCompany;
    }
    /**
     * Set AgencyCompany value
     * @param string $agencyCompany
     * @return \StructType\ViewChangedTAData
     */
    public function setAgencyCompany($agencyCompany = null)
    {
        // validation for constraint: string
        if (!is_null($agencyCompany) && !is_string($agencyCompany)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agencyCompany, true), gettype($agencyCompany)), __LINE__);
        }
        $this->AgencyCompany = $agencyCompany;
        return $this;
    }
    /**
     * Get AgencyEmail value
     * @return string|null
     */
    public function getAgencyEmail()
    {
        return $this->AgencyEmail;
    }
    /**
     * Set AgencyEmail value
     * @param string $agencyEmail
     * @return \StructType\ViewChangedTAData
     */
    public function setAgencyEmail($agencyEmail = null)
    {
        // validation for constraint: string
        if (!is_null($agencyEmail) && !is_string($agencyEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agencyEmail, true), gettype($agencyEmail)), __LINE__);
        }
        $this->AgencyEmail = $agencyEmail;
        return $this;
    }
    /**
     * Get AgencyAddress1 value
     * @return string|null
     */
    public function getAgencyAddress1()
    {
        return $this->AgencyAddress1;
    }
    /**
     * Set AgencyAddress1 value
     * @param string $agencyAddress1
     * @return \StructType\ViewChangedTAData
     */
    public function setAgencyAddress1($agencyAddress1 = null)
    {
        // validation for constraint: string
        if (!is_null($agencyAddress1) && !is_string($agencyAddress1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agencyAddress1, true), gettype($agencyAddress1)), __LINE__);
        }
        $this->AgencyAddress1 = $agencyAddress1;
        return $this;
    }
    /**
     * Get AgencyAddress2 value
     * @return string|null
     */
    public function getAgencyAddress2()
    {
        return $this->AgencyAddress2;
    }
    /**
     * Set AgencyAddress2 value
     * @param string $agencyAddress2
     * @return \StructType\ViewChangedTAData
     */
    public function setAgencyAddress2($agencyAddress2 = null)
    {
        // validation for constraint: string
        if (!is_null($agencyAddress2) && !is_string($agencyAddress2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agencyAddress2, true), gettype($agencyAddress2)), __LINE__);
        }
        $this->AgencyAddress2 = $agencyAddress2;
        return $this;
    }
    /**
     * Get AgencyCity value
     * @return string|null
     */
    public function getAgencyCity()
    {
        return $this->AgencyCity;
    }
    /**
     * Set AgencyCity value
     * @param string $agencyCity
     * @return \StructType\ViewChangedTAData
     */
    public function setAgencyCity($agencyCity = null)
    {
        // validation for constraint: string
        if (!is_null($agencyCity) && !is_string($agencyCity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agencyCity, true), gettype($agencyCity)), __LINE__);
        }
        $this->AgencyCity = $agencyCity;
        return $this;
    }
    /**
     * Get AgencyCountry value
     * @return string|null
     */
    public function getAgencyCountry()
    {
        return $this->AgencyCountry;
    }
    /**
     * Set AgencyCountry value
     * @param string $agencyCountry
     * @return \StructType\ViewChangedTAData
     */
    public function setAgencyCountry($agencyCountry = null)
    {
        // validation for constraint: string
        if (!is_null($agencyCountry) && !is_string($agencyCountry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agencyCountry, true), gettype($agencyCountry)), __LINE__);
        }
        $this->AgencyCountry = $agencyCountry;
        return $this;
    }
    /**
     * Get AgencyIATA value
     * @return string|null
     */
    public function getAgencyIATA()
    {
        return $this->AgencyIATA;
    }
    /**
     * Set AgencyIATA value
     * @param string $agencyIATA
     * @return \StructType\ViewChangedTAData
     */
    public function setAgencyIATA($agencyIATA = null)
    {
        // validation for constraint: string
        if (!is_null($agencyIATA) && !is_string($agencyIATA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agencyIATA, true), gettype($agencyIATA)), __LINE__);
        }
        $this->AgencyIATA = $agencyIATA;
        return $this;
    }
    /**
     * Get AgencyParentalIATA value
     * @return string|null
     */
    public function getAgencyParentalIATA()
    {
        return $this->AgencyParentalIATA;
    }
    /**
     * Set AgencyParentalIATA value
     * @param string $agencyParentalIATA
     * @return \StructType\ViewChangedTAData
     */
    public function setAgencyParentalIATA($agencyParentalIATA = null)
    {
        // validation for constraint: string
        if (!is_null($agencyParentalIATA) && !is_string($agencyParentalIATA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agencyParentalIATA, true), gettype($agencyParentalIATA)), __LINE__);
        }
        $this->AgencyParentalIATA = $agencyParentalIATA;
        return $this;
    }
    /**
     * Get AgencyPhoneNumber value
     * @return string|null
     */
    public function getAgencyPhoneNumber()
    {
        return $this->AgencyPhoneNumber;
    }
    /**
     * Set AgencyPhoneNumber value
     * @param string $agencyPhoneNumber
     * @return \StructType\ViewChangedTAData
     */
    public function setAgencyPhoneNumber($agencyPhoneNumber = null)
    {
        // validation for constraint: string
        if (!is_null($agencyPhoneNumber) && !is_string($agencyPhoneNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agencyPhoneNumber, true), gettype($agencyPhoneNumber)), __LINE__);
        }
        $this->AgencyPhoneNumber = $agencyPhoneNumber;
        return $this;
    }
    /**
     * Get AgencyFaxNumber value
     * @return string|null
     */
    public function getAgencyFaxNumber()
    {
        return $this->AgencyFaxNumber;
    }
    /**
     * Set AgencyFaxNumber value
     * @param string $agencyFaxNumber
     * @return \StructType\ViewChangedTAData
     */
    public function setAgencyFaxNumber($agencyFaxNumber = null)
    {
        // validation for constraint: string
        if (!is_null($agencyFaxNumber) && !is_string($agencyFaxNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agencyFaxNumber, true), gettype($agencyFaxNumber)), __LINE__);
        }
        $this->AgencyFaxNumber = $agencyFaxNumber;
        return $this;
    }
    /**
     * Get AgencyFieldChangedDate value
     * @return string|null
     */
    public function getAgencyFieldChangedDate()
    {
        return $this->AgencyFieldChangedDate;
    }
    /**
     * Set AgencyFieldChangedDate value
     * @param string $agencyFieldChangedDate
     * @return \StructType\ViewChangedTAData
     */
    public function setAgencyFieldChangedDate($agencyFieldChangedDate = null)
    {
        // validation for constraint: string
        if (!is_null($agencyFieldChangedDate) && !is_string($agencyFieldChangedDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agencyFieldChangedDate, true), gettype($agencyFieldChangedDate)), __LINE__);
        }
        $this->AgencyFieldChangedDate = $agencyFieldChangedDate;
        return $this;
    }
    /**
     * Get ChangedFields value
     * @return \ArrayType\ArrayOfEnumerations_AgencyFields|null
     */
    public function getChangedFields()
    {
        return $this->ChangedFields;
    }
    /**
     * Set ChangedFields value
     * @param \ArrayType\ArrayOfEnumerations_AgencyFields $changedFields
     * @return \StructType\ViewChangedTAData
     */
    public function setChangedFields(\ArrayType\ArrayOfEnumerations_AgencyFields $changedFields = null)
    {
        $this->ChangedFields = $changedFields;
        return $this;
    }
}
