<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ViewDisruptedAgencyPNR StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ViewDisruptedAgencyPNR
 * @subpackage Structs
 */
class ViewDisruptedAgencyPNR extends AbstractStructBase
{
    /**
     * The BookingRef
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $BookingRef;
    /**
     * The DepartureDate
     * @var string
     */
    public $DepartureDate;
    /**
     * The Destination
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Destination;
    /**
     * The FlightNumber
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $FlightNumber;
    /**
     * The NotificationComments
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $NotificationComments;
    /**
     * The NotifyPAXFlag
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $NotifyPAXFlag;
    /**
     * The Origin
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Origin;
    /**
     * The PrimaryPAXEmailId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $PrimaryPAXEmailId;
    /**
     * The PrimaryPAXTelephoneNumber
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $PrimaryPAXTelephoneNumber;
    /**
     * The PrimaryPassengerName
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $PrimaryPassengerName;
    /**
     * The RecordId
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $RecordId;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $Status;
    /**
     * The Exceptions
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \StructType\ExceptionInformation_Exceptions
     */
    public $Exceptions;
    /**
     * Constructor method for ViewDisruptedAgencyPNR
     * @uses ViewDisruptedAgencyPNR::setBookingRef()
     * @uses ViewDisruptedAgencyPNR::setDepartureDate()
     * @uses ViewDisruptedAgencyPNR::setDestination()
     * @uses ViewDisruptedAgencyPNR::setFlightNumber()
     * @uses ViewDisruptedAgencyPNR::setNotificationComments()
     * @uses ViewDisruptedAgencyPNR::setNotifyPAXFlag()
     * @uses ViewDisruptedAgencyPNR::setOrigin()
     * @uses ViewDisruptedAgencyPNR::setPrimaryPAXEmailId()
     * @uses ViewDisruptedAgencyPNR::setPrimaryPAXTelephoneNumber()
     * @uses ViewDisruptedAgencyPNR::setPrimaryPassengerName()
     * @uses ViewDisruptedAgencyPNR::setRecordId()
     * @uses ViewDisruptedAgencyPNR::setStatus()
     * @uses ViewDisruptedAgencyPNR::setExceptions()
     * @param string $bookingRef
     * @param string $departureDate
     * @param string $destination
     * @param string $flightNumber
     * @param string $notificationComments
     * @param string $notifyPAXFlag
     * @param string $origin
     * @param string $primaryPAXEmailId
     * @param string $primaryPAXTelephoneNumber
     * @param string $primaryPassengerName
     * @param string $recordId
     * @param string $status
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     */
    public function __construct($bookingRef = null, $departureDate = null, $destination = null, $flightNumber = null, $notificationComments = null, $notifyPAXFlag = null, $origin = null, $primaryPAXEmailId = null, $primaryPAXTelephoneNumber = null, $primaryPassengerName = null, $recordId = null, $status = null, \StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        $this
            ->setBookingRef($bookingRef)
            ->setDepartureDate($departureDate)
            ->setDestination($destination)
            ->setFlightNumber($flightNumber)
            ->setNotificationComments($notificationComments)
            ->setNotifyPAXFlag($notifyPAXFlag)
            ->setOrigin($origin)
            ->setPrimaryPAXEmailId($primaryPAXEmailId)
            ->setPrimaryPAXTelephoneNumber($primaryPAXTelephoneNumber)
            ->setPrimaryPassengerName($primaryPassengerName)
            ->setRecordId($recordId)
            ->setStatus($status)
            ->setExceptions($exceptions);
    }
    /**
     * Get BookingRef value
     * @return string|null
     */
    public function getBookingRef()
    {
        return $this->BookingRef;
    }
    /**
     * Set BookingRef value
     * @param string $bookingRef
     * @return \StructType\ViewDisruptedAgencyPNR
     */
    public function setBookingRef($bookingRef = null)
    {
        // validation for constraint: string
        if (!is_null($bookingRef) && !is_string($bookingRef)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($bookingRef, true), gettype($bookingRef)), __LINE__);
        }
        $this->BookingRef = $bookingRef;
        return $this;
    }
    /**
     * Get DepartureDate value
     * @return string|null
     */
    public function getDepartureDate()
    {
        return $this->DepartureDate;
    }
    /**
     * Set DepartureDate value
     * @param string $departureDate
     * @return \StructType\ViewDisruptedAgencyPNR
     */
    public function setDepartureDate($departureDate = null)
    {
        // validation for constraint: string
        if (!is_null($departureDate) && !is_string($departureDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($departureDate, true), gettype($departureDate)), __LINE__);
        }
        $this->DepartureDate = $departureDate;
        return $this;
    }
    /**
     * Get Destination value
     * @return string|null
     */
    public function getDestination()
    {
        return $this->Destination;
    }
    /**
     * Set Destination value
     * @param string $destination
     * @return \StructType\ViewDisruptedAgencyPNR
     */
    public function setDestination($destination = null)
    {
        // validation for constraint: string
        if (!is_null($destination) && !is_string($destination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($destination, true), gettype($destination)), __LINE__);
        }
        $this->Destination = $destination;
        return $this;
    }
    /**
     * Get FlightNumber value
     * @return string|null
     */
    public function getFlightNumber()
    {
        return $this->FlightNumber;
    }
    /**
     * Set FlightNumber value
     * @param string $flightNumber
     * @return \StructType\ViewDisruptedAgencyPNR
     */
    public function setFlightNumber($flightNumber = null)
    {
        // validation for constraint: string
        if (!is_null($flightNumber) && !is_string($flightNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($flightNumber, true), gettype($flightNumber)), __LINE__);
        }
        $this->FlightNumber = $flightNumber;
        return $this;
    }
    /**
     * Get NotificationComments value
     * @return string|null
     */
    public function getNotificationComments()
    {
        return $this->NotificationComments;
    }
    /**
     * Set NotificationComments value
     * @param string $notificationComments
     * @return \StructType\ViewDisruptedAgencyPNR
     */
    public function setNotificationComments($notificationComments = null)
    {
        // validation for constraint: string
        if (!is_null($notificationComments) && !is_string($notificationComments)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($notificationComments, true), gettype($notificationComments)), __LINE__);
        }
        $this->NotificationComments = $notificationComments;
        return $this;
    }
    /**
     * Get NotifyPAXFlag value
     * @return string|null
     */
    public function getNotifyPAXFlag()
    {
        return $this->NotifyPAXFlag;
    }
    /**
     * Set NotifyPAXFlag value
     * @param string $notifyPAXFlag
     * @return \StructType\ViewDisruptedAgencyPNR
     */
    public function setNotifyPAXFlag($notifyPAXFlag = null)
    {
        // validation for constraint: string
        if (!is_null($notifyPAXFlag) && !is_string($notifyPAXFlag)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($notifyPAXFlag, true), gettype($notifyPAXFlag)), __LINE__);
        }
        $this->NotifyPAXFlag = $notifyPAXFlag;
        return $this;
    }
    /**
     * Get Origin value
     * @return string|null
     */
    public function getOrigin()
    {
        return $this->Origin;
    }
    /**
     * Set Origin value
     * @param string $origin
     * @return \StructType\ViewDisruptedAgencyPNR
     */
    public function setOrigin($origin = null)
    {
        // validation for constraint: string
        if (!is_null($origin) && !is_string($origin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($origin, true), gettype($origin)), __LINE__);
        }
        $this->Origin = $origin;
        return $this;
    }
    /**
     * Get PrimaryPAXEmailId value
     * @return string|null
     */
    public function getPrimaryPAXEmailId()
    {
        return $this->PrimaryPAXEmailId;
    }
    /**
     * Set PrimaryPAXEmailId value
     * @param string $primaryPAXEmailId
     * @return \StructType\ViewDisruptedAgencyPNR
     */
    public function setPrimaryPAXEmailId($primaryPAXEmailId = null)
    {
        // validation for constraint: string
        if (!is_null($primaryPAXEmailId) && !is_string($primaryPAXEmailId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($primaryPAXEmailId, true), gettype($primaryPAXEmailId)), __LINE__);
        }
        $this->PrimaryPAXEmailId = $primaryPAXEmailId;
        return $this;
    }
    /**
     * Get PrimaryPAXTelephoneNumber value
     * @return string|null
     */
    public function getPrimaryPAXTelephoneNumber()
    {
        return $this->PrimaryPAXTelephoneNumber;
    }
    /**
     * Set PrimaryPAXTelephoneNumber value
     * @param string $primaryPAXTelephoneNumber
     * @return \StructType\ViewDisruptedAgencyPNR
     */
    public function setPrimaryPAXTelephoneNumber($primaryPAXTelephoneNumber = null)
    {
        // validation for constraint: string
        if (!is_null($primaryPAXTelephoneNumber) && !is_string($primaryPAXTelephoneNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($primaryPAXTelephoneNumber, true), gettype($primaryPAXTelephoneNumber)), __LINE__);
        }
        $this->PrimaryPAXTelephoneNumber = $primaryPAXTelephoneNumber;
        return $this;
    }
    /**
     * Get PrimaryPassengerName value
     * @return string|null
     */
    public function getPrimaryPassengerName()
    {
        return $this->PrimaryPassengerName;
    }
    /**
     * Set PrimaryPassengerName value
     * @param string $primaryPassengerName
     * @return \StructType\ViewDisruptedAgencyPNR
     */
    public function setPrimaryPassengerName($primaryPassengerName = null)
    {
        // validation for constraint: string
        if (!is_null($primaryPassengerName) && !is_string($primaryPassengerName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($primaryPassengerName, true), gettype($primaryPassengerName)), __LINE__);
        }
        $this->PrimaryPassengerName = $primaryPassengerName;
        return $this;
    }
    /**
     * Get RecordId value
     * @return string|null
     */
    public function getRecordId()
    {
        return $this->RecordId;
    }
    /**
     * Set RecordId value
     * @param string $recordId
     * @return \StructType\ViewDisruptedAgencyPNR
     */
    public function setRecordId($recordId = null)
    {
        // validation for constraint: string
        if (!is_null($recordId) && !is_string($recordId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($recordId, true), gettype($recordId)), __LINE__);
        }
        $this->RecordId = $recordId;
        return $this;
    }
    /**
     * Get Status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param string $status
     * @return \StructType\ViewDisruptedAgencyPNR
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Get Exceptions value
     * @return \StructType\ExceptionInformation_Exceptions|null
     */
    public function getExceptions()
    {
        return $this->Exceptions;
    }
    /**
     * Set Exceptions value
     * @param \StructType\ExceptionInformation_Exceptions $exceptions
     * @return \StructType\ViewDisruptedAgencyPNR
     */
    public function setExceptions(\StructType\ExceptionInformation_Exceptions $exceptions = null)
    {
        $this->Exceptions = $exceptions;
        return $this;
    }
}
